Registering UltraCompare
Next Topic

Internet Activation

Internet Activation is the primary method of registering UltraCompare. When the Enter license key option is selected from the Application Menu , the Internet Activation dialog will be displayed. The easiest method of entering the required License ID and Password is to copy them from the registration email and paste them into the dialog.

The password provided for UltraCompare is case sensitive and must be entered EXACTLY as received from IDM Computer Solutions, Inc.

After entering the License ID and Password, the user must press the Activate button to validate the license with the registration server. After the License ID and Password have been validated, the user will see a dialog indicating that Activation was successful.

If necessary, users may press the Proxy button in the Internet Activation dialog to enter the name or IP address for the proxy server and the port number to be used as appropriate. For most users this should not be necessary as UltraCompare will default to the proxy settings specified for Internet Explorer.

Offline Activation

If online activation is not possible because there is no Internet connection available, users may use the offline activation dialog to register. When the Offline Activation button is pressed in the Internet Activation dialog, the dialog below will be displayed. The top two fields will be populated with numeric values. These should be sent to support@idmcomp.com in an email and we will reply with values that may be entered in the Authorization Code fields.

Please note: If any values other than those provided by IDM Computer Solutions, Inc. are entered here, this will cause the values in the first two fields to be re-calculated the next time the Offline Activation dialog is opened. Please do not enter any values except those provided by our support team.


Opening Files

There are many methods for opening files to be compared in UltraCompare. The method chosen really is a matter of preference as all the methods described below will result in the same internal function - namely opening the specified files and automatically beginning a comparison of the specified files.

UltraEdit

If you are running UltraCompare Lite you must have UltraEdit or UEStudio running in order to compare files in UltraCompare Lite. If you wish you may open the files to be compared in UltraEdit or UEStudio and invoke UltraCompare Lite using the Compare Files command in the File menu. By default the last two files opened/edited would populate the combo boxes in the Compare Files dialog. If you prefer, you may simply use this dialog's Browse buttons to browse to and specify the files you'd like to compare.

Along with specifying files to be opened in UltraCompare Lite, you may select whether the specified files should be compared as Text or Binary files as well as specifying any (or all) of the three compare options in this dialog as well:

Ignore Case

Ignore Spaces

Ignore Blank Lines

Please note that these options only apply to Text Compares.

Command Line

If you are running UltraCompare Professional you may specify files to be opened and compared from the command line. If UltraCompare has been added to your PATH it may be invoked from the command line (i.e. a DOS prompt) for comparing files as follows:

uc c:\ temp\test.txt d:\ temp\test.txt

This would cause UltraCompare to open test.txt from the two different drives in the left and right panes and automatically begin comparing them. While the compare is in progress the Cancel button on the toolbar will be active. The status bar will show a yellow light and the "Processing" label.

If UltraCompare has NOT been added to your PATH you would need to reference the full path to the application in order to invoke it from the command line, i.e.:

" c:\program files\ultracompare\uc" c:\ temp\test.txt d:\ temp\test.txt

There are several command line options that may be used when invoking UltraCompare Professional from the command line.

Open Left/Right

UltraCompare Professional also includes Open Left and Open Right commands in the File menu. Selecting either of these will open a standard file open dialog which you may use to browse to and select the file you'd like to be opened in the specified compare pane.

Combobox/Text Entry

If you prefer you may type directly in the Combobox above each compare pane to specify the file to be opened in the pane below. By default, the comparison of specified files will not begin until the Go button is pressed.

Users may specify files on a local/network file system for comparison. A URL for Internet content may also be entered and the source for the specified path will be downloaded and displayed in the compare pane. URL's must start with "www" or "http://" as appropriate. Users may toggle the browser view to modify the source and save the modified source code to a local file. The paths for files which have previously been compared are stored in the combo boxes and users may click on the down arrow and select from previous files for comparison if desired.

Pasted Text

If desired, users may copy and paste text into each of the empty compare panes. Temporary file paths will be created and displayed for the contents of each pane. The "close" button may be used to dismiss a temporary file if users wish to compare a different code snippet. The comparison will begin as soon as the contents of the second file are pasted into the compare pane. Pasted text may also be compared against an existing file.

Browse Button

You may click on the open button in the upper right corner of either pane to open a standard file open dialog and select the file you wish to open using this.

Once both files are opened UltraCompare will automatically begin comparing their contents. When this is completed the file compare results will be indicated with a combination of colors and symbols.


Table Compare

When the Table Compare is completed the result of the compare will be indicated in the application using a combination of symbols and colors.

<! | indicates that data is in the left file but not the right file
!> | indicates that data is in the right file but not the left file
* | indicates that data is different between the compared files on the indicated line

The status bar will also indicate the number of blocks and lines containing differences in the compared files. For example:

1 Row(s) block diff 2 Column block(s) diff 13:13 row(s) diff 4:5 Column(s) diff

would indicate that there are 1 Row block where differences have been detected consisting 13 rows in the left and right file, and 2 Column blocks where differences have been detected, consisting of 4 columns in the left file and 5 columns in the right file.

Word Level Selection, Replace and Insertion

During a table compare the user may select words in one compare pane and copy them to the clipboard using the context menu or CTRL+C. After clicking in the other compare pane, the user may insert the contents of the clipboard or overwrite a specific word by pasting using the context menu or CTRL+V. Users may also edit directly in the compare panes, selecting, overwriting, and inserting text as desired.


Text Compare

When the Text Compare is completed the result of the compare will be indicated in the application using a combination of symbols and colors.

<! | indicates that data is in the left file but not the right file
!> | indicates that data is in the right file but not the left file
* | indicates that data is different between the compared files on the indicated line

The status bar will also indicate the number of blocks and lines containing differences in the compared files. For example:

38 block(s) diff 156:204 line(s) diff

would indicate that there are 38 blocks where differences have been detected between the compared files and that the Source (left) file contains 156 lines of text in these differenced blocks and the Destination (right) file contains 204 lines in these differenced blocks.

If Differences in context result is selected in the Backup & Save pane in Configuration the following symbols will be used:

+++ | identifies the file in the first pane
--- | identifies the file in the second pane
+ | indicates that text is from the file in the first pane
- | indicates that text is from the file in the second pane

@@ +1201,4 -1204,4 @@ indicates that the differenced text begins on line 1201 in the first pane and line 1204 in the second pane and the number of lines including differences for this section is 4.

Word Level Selection, Replace and Insertion

During a text compare the user may select words in one compare pane and copy them to the clipboard using the context menu or CTRL+C. After clicking in the other compare pane, the user may insert the contents of the clipboard or overwrite a specific word by pasting using the context menu or CTRL+V. Users may also edit directly in the compare panes, selecting, overwriting, and inserting text as desired.


3-Way Text Compare

When the 3-Way Text Compare is completed the result of the compare will be indicated in the application using a combination of symbols and colors.

<! indicates that data is in the left file but not the right file

!> indicates that data is in the right file but not the left file

!! indicates that this section contains empty lines in both files

* indicates that data is different between the compared files on the indicated line.

Along with the items above, lines detected as being different will be highlighted with the color specified for the Difference Background in the Colors dialog. The active line is indicated with the color specified for the Navigation Background (by default a peach color). If Mark empty lines is selected in the Colors dialog, empty sections (containing no data and no hard returns) will be indicated in the scaled/scrollable map with vertical blue bars on a white background.

Where it is observed that lines in Frame 2 are highlighted with a blue block fading to white toward one of the files being compared, this means that the block in Frame 2 matches the same block in Frame 1 but is different from the same block in Frame 3 (or vice-versa).

The status bar will also indicate the number of blocks and lines containing differences in the pair of files selected for comparison. For example:

Pair [2-3] - 33 Block(s) diff 286 : 395 Line(s) diff

would indicate that the active pair of files (of the three files open for comparison) is Frame 2 and Frame 3 and that there are 33 blocks where differences have been detected between the compared files and that the file in Frame 2 contains 286 lines of text in these differenced blocks and the file in Frame 3 contains 395 lines in these differenced blocks.


Printed Result Summary

Printed Results Summary

The result summary is the text output of the active compare. It uses the following symbols:

Text Compare

<! | data is in the left file but not in the right file
!> | data is in the right file but not in the left file
* | data is different between the compared files on this line

Folder Compare

_x | file is in directory on left (Source) but not directory on right (Destination)
x_ | file is in directory on right (Destination) but not directory on left (Source)


Delete File

This is a context menu option available while comparing two files. If you right-click within the pane for either compared file the context menu appears with this option. Selecting this option will cause a prompt to appear showing the full path of the active file to confirm that you do wish to delete the active file. If "yes" is selected the file will be deleted and will be removed from the active compare pane. If "no" is selected the prompt dialog is dismissed and focus returns to the active document pane.


Opening Folders

Directories/folders you wish to open and compare in UltraCompare must be specified on the command line as follows:

uc - d c:\ temp\test c:\temp\test1

The - d flag indicates that directories/folders, and not files, should be opened for comparison.

If UltraCompare has NOT been added to your PATH you would need to reference the full path to the application in order to invoke it from the command line, i.e.:

" c:\program files\ultracompare\uc" - d c:\ temp\test c:\temp\test1

Please note that only UltraCompare Pro supports Command Line Options . UltraCompare Lite does not support opening/comparing directories/folders.


Folder Compare

Folder Compare Compare

If you're using UltraCompare Professional, directories/folders to be compared may be opened from the command line with the following syntax:

uc - d c:\temp d:\temp

Please note: If UltraCompare is not in your PATH you would need to reference the full path to UltraCompare for this to work.

While UltraCompare is preparing the directory structure for display the Cancel button on the toolbar will be active and colored and may be pressed to cancel the compare. During this time the middle (yellow) light on the status bar will be highlighted and the label "Progress" will be shown to indicate that UltraCompare is working. When the directory structure is ready for display either the red light and the label "Different" will be displayed or the green light and the label "Matching" will be displayed. (This feature is only available in UltraCompare Pro and not the Lite version.)

A .zip archive may be selected for comparison against a folder on the file system, if desired. Both recursive and non-recursive compares against .zip archives are supported.

If the recursive compare option is not selected then the Status column in the compare will indicate if listed subdirectories are in both directories or if they're only in the source or destination directories. If the recursive compare option is selected then the Status column will indicate whether subdirectories are identical or different or if they only exist in one of the parent directories.

If UltraCompare Professional is already running in Text Compare mode you may go to the View menu and select Directory mode to switch to the folder compare interface. Any files currently open in Text/Binary compare mode will not be remembered should you switch back from Directory mode.

If desired, the user may select files with different names and launch a Text Compare. To do this, right click on a file referenced in the Folder Compare and select Load First File (or second, or third) from the context menu and specify the frame the selected file should be loaded to. After specifying the other file(s) to be compared, double-clicking on the last file specified will launch a Text Compare with the specified files.

After a folder compare completes, the user may select the Sync Folders checkbox to synchronize the contents of the compared directories, if desired.


Folder Compare Elements

After UltraCompare has completed comparison of the specified directories the results are presented in the main window. The categories in which differences are specified are as follows:

File Name

The contents of the compare directories are arranged according to the names of the files in the directories that are being compared. This should be a complete listing of the combined contents of both directories.

Status

The Status field identifies what differences have been found between the compared directories. Possible values here are:

Identical: indicates that the contents of the file are exactly the same in both directories.

Same Time, Content Diff: indicates that the time stamp for both files is the same, but there are content differences between the compared files.

Source Newer: indicates that the directory specified on the left contains a newer copy of the file being compared.

Destination Newer: indicates that the directory specified on the right contains a newer copy of the file being compared.

Source Only: indicates that the file only exists in the directory on the left.

Destination Only: indicates that the file only exists in the directory on the right.

Src Date

The Src Date field shows the date and time stamp of the files in the directory specified on the left.

Src Size

The Src Size field shows the size in bytes of the files in the directory specified on the left.

Dest Date

The Dest Date field shows the date and time stamp of the files in the directory specified on the right.

Dest Size

The Dest Size field shows the size in bytes of the files in the directory specified on the right.

File Type

The File Type field indicates whether a file has been identified as being in Text or Binary format. If a subdirectory is listed this field will label this as a Directory rather than using one of the file types


Parent Directory

This option resets both directories being compared to their parent directory. This can be useful when a recursive compare is being done. If the user double-clicks on a subdirectory to see differences here, the Parent Directory button may be used to return to the previously compared parent directories.


Recursive Folder Compare

When comparing two directories you can press the Recursive Compare button in the toolbar. This will cause the selected directories to be compared a second time so that more information is provided regarding subdirectories found in the specified directories.

With the recursive option, the Status column will indicate the following regarding listed subdirectories:

Identical: indicates that the contents of this subdirectory are the same between both parent directories

Different: indicates there are differences between the contents of this subdirectory in the parent directories

Source Only: indicates that the subdirectory only exists in the Source (left) directory

Destination Only: indicates that the subdirectory only exists in the Destination (right) directory

If you wish, you may double click on a subdirectory folder. This will open the selected subdirectory in both parent directories for compare. You may press the Parent Directory button to navigate up one level through the directory structure.


Difference Navigation

Differences Navigation

There are two very useful methods for navigating the differences detected by UltraCompare when two files are compared: the View Next Difference and View Prev Difference buttons and the graphical navigation map shown to the left of the compare panes.

Clicking on the View Next Difference button or pressing F3 will position the cursor at the next difference in the active compare and clicking on the View Prev Difference or pressing F4 will position the cursor at the last difference previous to the current cursor position in the active compare. These give the user an easy method for stepping through differences sequentially without having to manually search them out. These are available for navigation of all differences including Text Compares, Binary (smart) Compares, Binary (fast) Compares, and Directory Compares.

In Text Compare Mode, when the active line is part of a block of differenced text, the user may press F7 to move to the next difference within the block and F8 to move to the previous difference within the block.

The graphical navigation map is displayed to the left of the compare panes during Text Compares. By default this is displayed in scrollable mode. If you prefer, you may click on the Scalable Map / Scrollable Map toggle in the View menu to switch to a scalable rather than scrollable navigation map. In this mode the differences are represented for the entirety of both compared files rather than shown as a scrollable map.

Matching sections of the compared files are indicated by white blocks in the navigation map. Sections where differences occur are indicated (by default) with blue blocks. Double clicking on the graphical navigation map will position the compared files accordingly. This allows very quick point-to-point navigation within the files rather than sequentially stepping through differences and also presents a quick overview of the number of differences between compared files. The red rectangle displayed within this space represents the visible portion of the files being compared.


Command Line Options

Command line parameters allow users to invoke UltraCompare Professional from a command prompt and specify options related to the compare. Please note: It is not possible to invoke UltraCompare Lite from the command line.

There are certain rules that must be observed when building a command line string:

1. All parameters must be separated by a space.

2. Compare type switches such as -t, -3, -p, -x, -d, and -w must always immediately precede the related compare object (the paths for the files/folders being compared).

3. Logical units can appear in any order on the command line so long as they are paired with their related parameters:

Correct: uc -i -lt -B -b -t <path1> <path2> -o <output file path>

Incorrect: uc -t -i -o -lt -B -b <path1> <path2> <output file path>

The following command line parameters may be used to invoke UltraCompare Professional from the command line:

-3 | 3-way text compare mode
-a | sets Show All
-B | ignore blank lines in text compare mode
-b | ignore spaces in text compare mode
-d | folder compare mode
-dmb | sets Folder Compare type to Basic
-dmf | sets Folder Compare type to Full
-dms | sets Folder Compare type to Smart
-fb | force all files to be compared as binary in folder compare mode
-ft | force all files to be compared as text in folder compare mode
-horz | sets view to horizontal layout
-i | ignore case in text compare mode
-lt | ignore line terminators
-m | sets Show Matching
-mc | set Show Matching Columns (Table Compare)
-mr | set Show Matching Rows (Table Compare)
-ne | set Show Differences
-nec | set Show Different Columns (Table Compare)
-ner | set Show Different Rows (Table Compare)
-o | creates output file
-op | appends output to specified file
-p | fast binary compare mode
-prf | runs specified session profile
-qc | quick difference check performs a byte by byte check until the first difference is detected
-r | compare folders recursively in folder compare mode
-rio | reset ignore options
-rom | read only merge mode
-t | text compare mode
-tb | table compare mode
-title1 | sets alias/title name for file/folder in first pane
-title2 | sets alias/title name for file/folder in second pane
-title3 | sets alias/title name for file/folder in third pane
-vert | sets view to vertical layout
-w | 3-way folder compare mode
-x | smart binary compare mode

Compare Output Options

It is possible to invoke UltraCompare from the command line and generate an output file. For example, if the following syntax is used:

uc - t " c:\temp\test1\test1.txt" " c:\temp\test2\test2.txt" - o " c:\ temp\output.txt"

then the files named "test1.txt" and "test2.txt" would be compared and the output would be written to the "output.txt" file automatically.

If this syntax is used:

uc -3 " c:\temp\test1\test1.txt" " c:\temp\test2\test2.txt" " c:\temp\test3\test3.txt" - o " c:\ temp\output.txt"

then the files named "test1.txt", "test2.txt" and "test3.txt" would be compared and the output would be written to the "output.txt" file automatically.

The same may be done for folder compares using similar syntax as described above, i.e.:

uc -dmb -d "c:\temp\test1" "c:\temp\test2" -o "c:\temp\output.txt"

or

uc -dms -w "c:\temp\test1" "c:\temp\test2" "c:\temp\test3" -o "c:\temp\output.txt"

If desired, users may specify that output should be appended to an existing file rather than creating a new output file. This would be specified using the "-op" parameter. For example:

uc -t " c:\temp\test1\test1.txt" " c:\temp\test2\test2.txt" -op " c:\ temp\output.txt"

would append the output of the specified compare to the end of the "output.txt" file.

Text-Specific Compare Options

The Quick Difference Check "-qc" and Read Only Merge Mode "-rom" operators are exclusively text compare options, so the "-t" option is not required. For example:

uc -qc <path1> <path2>

would cause UltraCompare Professional to compare the two files specified. A byte by byte check will be performed until the first difference is detected. If a difference is detected the application returns a status of ‘different’ otherwise the application returns ‘same’.

Due to the fact that windows programs don't have a stdin, stdout, and stderr, an executable called uc.com is created to pass information back to the command line. In order to use this feature in the windows shell type the name of the executable "uc" (or "uc.com") with the proper command line arguments. The com file will execute, load uc.exe, pass the command line, and set up a communications channel with the application. This allows the user to receive a same or different message when executing the quick difference command line option. This is the same method used by MSDEV to communicate with the command line.

For Read Only Merge Mode the following syntax must be used:

uc -rom <path1> <path2> <path3>

<path1> and <path2> specify the files that are to be compared, but the intent is not to modify the original files at all during the compare/merge process. The file specified in <path1> will be copied to <path3> for comparison/merge. The file specified with <path3> will be displayed in the left pane and the file specified with <path2> will be displayed in the right pane.

Please note: It will only be possible to merge into the document specified with <path3>. The file this is being compared to will be locked as Read Only.

Folder-Specific Compare Options

The -dmb, -dmf, and -dms switches may be used to specify the type of folder compare that should be executed. For example:

uc -dmb -d "c:\temp\test1" "c:\temp\test2"

would invoke a Basic folder compare of the specified folders, while:

uc -dms -r -w "c:\temp\test1" "c:\temp\test2" "c:\temp\test3"

would invoke a recursive Smart folder compare of the specified directories. When performing a Smart folder mode compare, users can force UltraCompare to consider all included files to be text files (-ft) or binary files (-fb) as follows:

uc -ft -dms -d "c:\temp\test1" "c:\temp\test2"

or

uc -fb -dms -w "c:\temp\test1" "c:\temp\test2" "c:\temp\test3"

Please note: These options (-ft and -fb) should only be used when invoking a Smart folder compare (-dms).

Table -Specific Compare Options

The -mec, -mer, -nec, and -ner switches may be used to specify Just Matching Columns, Just Matching Rows, Just Different Columns, Just Different Rows (respectively). For example:

uc -tb "c:\temp\test1.csv" "c:\temp\test2.csv" -mc

would invoke a Table folder compare of the specified files and show only matching columns.

Ignore Options

Users may specify ignore options from the command line which may be used to refine the data returned from comparison of specified files/folders. For example:

uc -i -B -t "c:\temp\test1.txt" "c:\temp\test2.txt"

would invoke a text compare of the specified files while ignoring case differences as well as blank lines that might occur in either file. It is important to note that ignore options are not automatically reset when different commands are invoked, so if an ignore option is set, it will be inherited by the next command invoked. This means that if this command is executed:

uc -b -t "c:\temp\test1.txt" "c:\temp\test2.txt"

then a text compare would be invoked while ignoring whitespace that might occur in the files being compared. If this command is executed immediately following the completion of that command:

uc -lt -t "c:\temp\test1.txt" "c:\temp\test2.txt"

then both line terminators and whitespace would be ignored by the comparison. Users may reset ignore options by using the -rio switch, e.g.:

uc -rio -B -b -t "c:\temp\test1.txt" "c:\temp\test2.txt" -o "c:\temp\output.txt"

Display Options

Users may specify which differences are shown when the comparison is displayed in UltraCompare using the parameters -a, -m, or -ne. For example:

uc -dmb -d "c:\temp\test1.txt" "c:\temp\test2.txt" -ne

would invoke a folder compare of the specified folders, but would only display files and folders that are different when displaying the results of the comparison. The layout used to display the comparison results may also be specified from the command line using the switches -vert and -horz. For example:

uc -t "c:\temp\test1.txt" "c:\temp\test2.txt" -horz

would invoke a text compare of the specified files and would force the results to be displayed in a horizontally tiled layout.

Alias/Title Options

Some version control systems require that aliases, rather than full paths for the actual files/folders being compared, be used when invoking a compare of members of the version controlled repository. The following syntax may be used to support this requirement:

uc -t "c:\dev\workingFiles\appData.cpp" "c:\dev\workingFiles\appData.cpp" -title1 "appData1" -title2 "appData2"

In this case, the specified files would be compared, but only "appData1" and "appData2" would be displayed for the paths of the compared files when the result is displayed in UltraCompare Professional.


Version Control Support

UltraCompare Professional may be configured as the external diff utility for several VCS applications. The following instructions apply only to the Windows version of each product referenced.

AnkhSVN with Visual Studio 2008 (http://ankhsvn.open.collab.net/)

1. Open Visual Studio 2008.

2. Select Options from the Tools menu.

3. Select Source Control and click on Plug-In Selection.

4. Under Plug-In Selection select AnkhSVN.

5. Under Subversion User Tools enter the following into the External Diff field:

"C:\Program Files\IDM Computer Solutions\UltraCompare\uc.exe" "%base" "%mine"

Perforce for Windows (http://www.perforce.com/)

1. Select Preferences from the Edit menu.

2. Go to the Diff tab.

3. Under Default Diff Application select Other Application.

4. Click the browse button next to the Location box and browse to the UltraCompare install directory. Select uc.exe.

5. In the Arguments field, enter:

%1 %2

QVCS (http://www.qumasoft.com/index1.html)

1. Select Preferences from the Admin menu.

2. Go to the Utilities tab.

3. In the Visual Compare Utility Command Line field, enter:

"uc.exe %s %s"

4. Click Apply.

Subversion (http://subversion.tigris.org/)

1. Create a batch file named "ucsvndiff.bat" in the UltraCompare install directory (e.g. "C:\Program Files\IDM Computer Solutions\UltraCompare").

2. Open ucsvndiff.bat for editing..

3. Type the following:

%ECHO OFF

"C:\Program Files\IDM Computer Solutions\UltraCompare\uc.exe" "%6" "%7" -title1 %3 -title2 %5

3. Go to Subversion's configuration area, normally

C:\Users\<username>\AppData\Roaming\Subversion

or

C:\Users\<username>\Application Data\Subversion

(One way to find this folder is to enter %APPDATA% in the address bar and then search for the "Subversion" folder.)

4. Change the following lines in the "config" file in the "Subversion" folder:

#[helpers]

#diff-cmd=diff_program(diff, gdiff, etc.)

to:

[helpers]

diff-cmd=diff_program(diff, gdiff, etc.)

5. Edit the diff-cmd to point to the ucsvndiff.bat file, e.g.:

diff-cmd=C:\Program File\IDM Computer Solutions\UltraCompare\ucsvndiff.bat

TortoiseCVS (http://tortoisecvs.org/)

1. From context menu in Windows Explorer select CVS and then Preferences.

2. Select Tools tab.

3. For Diff application, browse to UltraCompare install directory and select uc.exe.

4. For Two-way diff parameters enter the following:

"%1" "%2"

Please note: A space must be inserted between the specified values.

TortoiseSVN (http://tortoisesvn.tigris.org/)

1. From context menu in Windows Explorer select TortoiseSVN and then Settings.

2. Go to Diff Viewer under External Programs.

3. Under "Configure the program used for comparing different revisions of files" select External.

4. Click browse button and browse to UltraCompare install directory. Select uc.exe and press OK.

5. Add the following string to the end of the uc.exe path:

%base %mine -title1 %bname -title2 %yname

6. The constructed string should now look like this:

C:\Program Files\IDM Computer Solutions\UltraCompare\uc.exe %base %mine -title1 %bname -title2 %yname

7. Press Apply button.

Visual SourceSafe 2005 (installed from Visual Studio DVD)

1. Select Options from Tools menu.

2. Select Custom Editors tab.

3. Select File Difference under Operation:.

4. In the File Extension field, enter: ".*"

5. In the Command Line field, enter:

C:\Program Files\IDM Computer Solutions\UltraCompare\uc.exe "%1" "%2"

6. Press Add button.


UltraCompare Versions

UltraCompare is available in both Lite and Pro versions. The Lite version is packaged with UltraEdit and must be invoked from within UltraEdit.

A summary of features is included below to show the differences between the versions:

The Lite Version:

* requires that UltraEdit be running

* must be invoked by UltraEdit

* only supports Text Compare (files)

The Pro version:

* is a standalone application and does not require that UltraEdit be running

* supports Folder Compare (directories) as well as Text Compare (files)

* supports fast binary compare, byte-by-byte

* supports smart binary compare where bytes are inserted and will realign

* supports merge of changes

* includes additional toolbar items not found in the Lite version

UltraCompare Pro also has several Command Line Options whereas UltraCompare Lite cannot be invoked from the command line.


Application Menu

The Application menu offers the following commands during a text/binary/folder compare:

Open First/Second/Third | invokes File Open dialog to specify file to be opened in first, second, or third pane
Favorites | presents a dialog for specifying most-used compare directories
Save Merged Changes | saves changes made during previous Merge operations
Save as | saves the contents of the active pane to the specified file name
Save Result | saves the result summary of the active compare as a text file
Print Result | prints the result summary
Print Preview | displays the result summary onscreen as it would appear printed
Print Setup/Configuration | displays Page Setup dialog for configuring print settings


Home Tab

The Home Tab offers the following commands

New Compare | presents submenu where user may select mode for creating next session - does not allow toggling between modes
Set Compare Options | presents Session Properties for active session
Rename | highlights text of active session tab so user may rename it
Save | saves active session
Save as new | save the current session with a new name
Group & save all | creates a new session group in Sessions pane of Workspace Manager and adds all active sessions to newly created group
Close | closes active session
Close all | close all active sessions
Close all except this | closes all sessions except the one current active
Mode | changes the current compare session mode
FTP - Open from FTP | opens an existing document from an FTP site
FTP - Save As to FTP | saves an opened document to a specified file name on an FTP site
FTP Accounts dialog | displays dialog to specify FTP accounts
Find Duplicates | invokes Find Duplicates dialog
UltraFinder | invokes UltraFinder options
Session Template | presents submenu where user may select mode for creating next session, and submenu for defining the session
Settings | invokes Settings menu
Check for updates | checks to see if an upgrade/hotfix is available for the version currently being used


Layout Tab

The Layout tab offers the following commands:

Themes | presents a submenu where users may access the Manage Themes dialog or select an existing theme
Themes - Manage Themes | presents Manage Themes dialog where users may configure colors for the application
Previous Tab | moves to the previous session tab
Next Tab | moves to the next session tab
Synchronized Vertical | synchronizes the compare panes so that both files may be scrolled vertically at the same time
Sync horizontal | synchronizes the compare panes so that both files may be scrolled horizontally at the same time
Sync bottom | synchronizes the compare panes so that both files and the additional frames may be scrolled horizontally at the same time
Synchronize | synchronizes the compare panes so that both files may be scrolled vertically at the same time
Active line window | enables a full width display of the active lines of each compared file at bottom of application
Output Window | displays the output window where the results of the commands executed for the active session are displayed
Explorer & sessions | displays the Explorer & Sessions dialog including the Explorer and Sessions panes
Legend & Filters | displays the Legend & Filters dialog which explains the items displayed in the active compare and allows users to control which elements are displayed in the active compare
File Preview | displays preview file for active folder compare


Edit Tab - Text Mode

The Edit tab offers the following commands when in Text Mode:

All | displays the entire contents of both compared files
Diffs only | displays only the lines with differences
Matches only | displays only the lines that are an exact match
Next Difference | repositions to the next difference in the compared files
Prev Difference | repositions to the previous difference in the compared files
Center on Difference | repositions the displayed files such that the current difference is centered
Next diff char | repositions to the next difference in the differenced block
Prev diff char | repositions to the previous difference in the differenced block
First to second | merges selected difference from first file to second file
First to second (before) | merges selected difference from first file above selected line of second file
First to second (after) | merges selected difference from first file below selected line of second file
Second to first | merges selected difference from second file to first file
Second to first (before) | merges selected difference from second file above selected line of first file
Second to first (after) | merges selected difference from second file below selected line of first file
All from left | merges all differences from left file to right file
All from right | merges all differences from right file to left file
Line Mode Merge | switches the merge function from block merge to selected line merge
Undo Merge | reverses the last merge action
Undo All Changes | reverses all unsaved changes to compared files/folders
Save Merged Changes | saves all merge changes made in the current compare session
Paste | pastes data from the clipboard into the document
Copy | copies data from active document to the clipboard
Cut | deletes data from active document and moves it to the clipboard
Copy Frame To Clipboard | copies content of active frame to clipboard obeying filters if applied
Find | searches for specified string in active file
Go To | repositions cursor to specified line/column in both files
Bookmarks | add line to bookmarks list
Delete bookmark | delete line from bookmarks list
Bookmarks | presents dialog box showing bookmarked lines for navigation
Next | changes focus to next bookmarked line
Previous | changes focus to previous bookmarked line
Open in UltraEdit | opens active file for editing in UltraEdit
UltraSentry | dialog to send file to UltraSentry shredder or digital locker
Delete | removes the selected files/folders from the active directory


View Tab - Text Mode

The View tab offers the following commands when in Text Mode:

Word wrap | toggles the Word Wrap state of the active document
Relational Lines Mode | changes presentation of text compare to display linking and border lines for differenced blocks between matching blocks of text
Spaces/tab | displays spaces, tabs, and new line characters as visible characters
Line endings | displays line ending markings
Line numbers | displays line numbers in the compared files
Compare Column Ranges | presents a dialog where the user may enter up to four ranges of columns to be compared
Ignore Column Ranges | presents a dialog where the user may enter up to four ranges of columns to be ignored
Ignore Blank Lines | forces the compare to ignore lines containing only line terminators when comparing the active files
Ignore Whitespace | forces the compare to ignore tabs and spaces when identifying differences in the active files
Ignore Case | forces the compare to ignore case when identifying differences in the active files
Ignore Line Terminators | forces the compare to ignore line terminator differences (DOS/UNIX/MAC) in the active files
More ignore options | opens Session Properties
Flip Frames | switches source/destination panes in active compare
Maximize first | toggles display of first pane between maximum and default sizes
Maximize second | toggles display of second pane between maximum and default sizes
Vertical Layout | displays compared files side-by-side (default view)
Horizontal Layout | displays compared files with one file above the other
Browser View | passes active document to default browser for OS


Edit Tab - 3 Way Text Mode

Edit Tab - 3 Way Text

The Edit tab offers the following commands when in 3 Way Text Mode:

All | displays the entire contents of both compared files
Diffs only | displays only the lines with differences
Matches only | displays only the lines that are an exact match
Next Difference | moves focus to the first line in the next group of lines marked as different
Prev Difference | moves focus to the first line in the previous group of lines marked as different
Center on Difference | repositions the displayed files such that the current difference is centered
Next diff char | moves focus to the next character marked as different in selected file
Prev diff char | move focus to the previous character marked as different in selected file
First to second | merges selected difference from left active file to right active file
First to second (before) | merges selected difference from left active file above selected line of right active file
First to second (after) | merges selected difference from left active file below selected line of right active file
Second to first | merges selected difference from right active file to left active file
Second to first (before) | merges selected difference from right active file above selected line of left active file
Second to first (after) | merges selected difference from right active file below selected line of left active file
All from left | merges all differences from left active file to right active file
All from right | merges all differences from right active file to left active file
Line Mode Merge | switches the merge function from block merge to selected line merge
Undo Merge | reverses the last merge action
Undo All Changes | reverses all unsaved changes to compared files/folders
Save Merged Changes | saves all merge changes made in the current compare session
Paste | pastes data from the clipboard into the document
Copy | copies data from active document to the clipboard
Cut | deletes data from active document and moves it to the clipboard
Copy Frame To Clipboard | copies content of active frame to clipboard obeying filters if applied
Find | searches for specified string in active file
Go To | repositions cursor to specified line/column in both files
Bookmarks | add line to bookmarks list
Delete bookmark | delete line from bookmarks list
Bookmarks | launches a dialog listing the currently specified bookmarks
Next | changes focus to next bookmarked line
Previous | changes focus to previous bookmarked line
Open in UltraEdit | opens active file for editing in UltraEdit
UltraSentry | dialog to send file to UltraSentry shredder or digital locker
Delete | removes the selected files/folders from the active directory


View Tab - 3 Way Text Mode

The View tab offers the following commands when in 3 Way Text Mode:

Word wrap | toggles the Word Wrap state of the active document
Relational Lines Mode | changes presentation of text compare to display linking and border lines for differenced blocks between matching blocks of text
Spaces/tab | displays spaces, tabs, and new line characters as visible characters
Line endings | displays line ending markings
Line numbers | displays line numbers in the compared files
Compare Column Ranges | presents a dialog where the user may enter up to four ranges of columns to be compared
Ignore Column Ranges | presents a dialog where the user may enter up to four ranges of columns to be ignored
Ignore Blank Lines | forces the compare to ignore lines containing only line terminators when comparing the active files
Ignore Whitespace | forces the compare to ignore tabs and spaces when identifying differences in the active files
Ignore Case | forces the compare to ignore case when identifying differences in the active files
Ignore Line Terminators | forces the compare to ignore line terminator differences (DOS/UNIX/MAC) in the active files
More ignore options | opens Session Properties
Flip Frames | switches source/destination panes in active compare
Maximize first | toggles display of first pane between maximum and default sizes
Maximize second | toggles display of second pane between maximum and default sizes
Maximize third | toggles display of third pane between maximum and default sizes
3 Way Comparison Vertical Layout | displays compared files side-by-side (default view)
3 Way Comparison Horizontal Layout | displays compared files with one file above the other
Browser View | passes active document to default browser for OS


Edit Tab - Binary Mode

The Edit tab offers the following commands when in Binary Mode:

Next Difference | repositions to the next difference in the compared files
Prev Difference | repositions to the previous difference in the compared files
Find | searches for specified string in active file
Next Tab | moves to the next session tab
Open in UltraEdit | opens active file for editing in UltraEdit
UltraSentry | dialog to send file to UltraSentry shredder or digital locker
Delete | removes the selected files/folders from the active directory


View Tab - Binary Mode

The View tab offers the following commands when in Binary Mode:

Decimal Offset | switches offset displayed in binary mode from HEX to decimal
Flip Frames | switches source/destination panes in active compare
Maximize first | toggles display of first pane between maximum and default sizes
Maximize second | toggles display of second pane between maximum and default sizes
Vertical Layout | displays compared files side-by-side (default view)
Horizontal Layout | displays compared files with one file above the other


Edit Tab - Folder Mode

The Edit tab offers the following commands when in Folder Mode:

All | displays the entire contents of both compared folders
Diffs only | displays only the files with differences
Matches only | displays only the files that are an exact match
Next Difference | repositions to the next difference in the compared folders
Prev Difference | repositions to the previous difference in the compared folders
First to second | merges selected file from first folder to second folder
Second to first | merges selected file from second folder to first folder
All from left | merges all missing files from left folder to right folder
All from right | merges all missing files from right folder to left folder
Folder sync | enables Folder Synchronization
Customize rules | launches folder sync rules dialog
Start sync | starts folder sync process
Stop sync | stops folder sync process
Open in UltraEdit | opens active file for editing in UltraEdit
UltraSentry | dialog to send file to UltraSentry shredder or digital locker
Delete | removes the selected files/folders from the active directory


View Tab - Folder Mode

The View tab offers the following commands when in Folder Mode:

Filter » Hide files » Same | hide all matching files from view
Filter » Hide files » Different | hide all different (not matched) files from view
Filter » Hide files » Common | hide files found in all compared folders
Filter » Hide files » Unique | hide files found in only one compared folder
Filter » Hide folders » Same | only folders containing no differences will be shown
Filter » Hide folders » Different | only folders containing differences will be shown
Filter » Hide folders » Common | hide all matching subfolders
Filter » Hide folders » Unique | hide all different subfolders
All from first to... | merges all missing files to either second or third folder
All from second to... | merges all missing files to either first or third folder
All from third to... | merges all missing files to either first or second folder
Open in UltraEdit | launches the files in UltraEdit
UltraSentry | dialog to send file to UltraSentry shredder or digital locker
Delete | delete selected file(s)


Edit Tab - 3 Way Folder Mode

The Edit tab offers the following commands when in 3 Way Folder Mode:

All | displays the entire contents of both compared folders
Diffs only | displays only the files with differences
Matches only | displays only the files that are an exact match
Next Difference | repositions to the next difference in the compared folders
Prev Difference | repositions to the previous difference in the compared folders
First to... | merges selected file to either second or third folder
Second to... | merges selected file to either first or third folder
Third to... | merges selected file to either first or second folder
All from first to... | merges all missing files to either second or third folder
All from second to... | merges all missing files to either first or third folder
All from third to... | merges all missing files to either first or second folder
Open in UltraEdit | opens active file for editing in UltraEdit
UltraSentry | dialog to send file to UltraSentry shredder or digital locker
Delete | removes the selected files/folders from the active directory


View Tab - 3 Way Folder Mode

The View tab offers the following commands when in 3 Way Folder Mode:

Filter » Hide files » Same | hide all matching files from view
Filter » Hide files » Different | hide all different (not matched) files from view
Filter » Hide files » Common | hide files found in all compared folders
Filter » Hide files » Unique | hide files found in only one compared folder
Filter » Hide folders » Same | only folders containing no differences will be shown
Filter » Hide folders » Different | only folders containing differences will be shown
Filter » Hide folders » Common | hide all matching subfolders
Filter » Hide folders » Unique | hide all different subfolders
Filter by name | filter by file name
Ignore time/date diffs | ignore timestamp
More ignore options | opens Session Properties
Collapse all | collapses all folders/hides all files
Expand all | expands all folders/shows all files
Flip Frames | switches source/destination panes in active compare
Maximize first | toggles display of first pane between maximum and default sizes
Maximize second | toggles display of second pane between maximum and default sizes
Maximize third | toggles display of third pane between maximum and default sizes


Edit Tab - Table Mode

The Edit tab offers the following commands when in Table Mode:

All | displays the entire contents of both compared files
Just matching columns | only columns containing no differences will be shown
Just matching rows | only rows containing no differences will be shown
Just different columns | only columns containing differences will be shown
Just different rows | only rows containing differences will be shown
Next Difference | repositions to the next difference in the compared files
Prev Difference | repositions to the previous difference in the compared files
Center on Difference | repositions the displayed files such that the current difference is centered
Next diff char | repositions to the next difference in the differenced block
Prev diff char | repositions to the previous difference in the differenced block
Cell to second | merges selected cell from first file to second file
Cell to first | merges selected cell from second file to first file
Row to second | merges selected row from first file to second file
Row to second (before) | merges selected row from first file above selected row of second file
Row to second (after) | merges selected row from first file below selected row of second file
Row to first | merges selected row from second tile to first
Row to first (before) | merges selected row from second file above selected row of first file
Row to first (after) | merges selected row from second file below selected row of first file
Column to second | merges selected column from first file to second file
Column to second (before) | merges selected column from first file above selected row of second file
Column to second (after) | merges selected column from first file below selected row of second file
Column to first | merges selected column from second tile to first
Column to first (before) | merges selected column from second file above selected row of first file
Column to first (after) | merges selected Column from second file below selected row of first file
All from left | merges all differences from left file to right file
All from right | merges all differences from right file to left file
Undo Merge | reverses the last merge action
Undo All Changes | reverses all unsaved changes to compared files/folders
Save Merged Changes | saves all merge changes made in the current compare session
Paste | pastes data from the clipboard into the document
Copy | copies data from active document to the clipboard
Cut | deletes data from active document and moves it to the clipboard
Copy Frame To Clipboard | copies content of active frame to clipboard obeying filters if applied
Open in UltraEdit | opens active file for editing in UltraEdit
UltraSentry | dialog to send file to UltraSentry shredder or digital locker
Delete | removes the selected files/folders from the active directory


View Tab - Table Mode

The View tab offers the following commands when in Table Mode:

Set ignore options | opens Session Properties
Flip Frames | switches source/destination panes in active compare
Maximize first | toggles display of first pane between maximum and default sizes
Maximize second | toggles display of second pane between maximum and default sizes
Vertical Layout | displays compared files side-by-side (default view)
Horizontal Layout | displays compared files with one file above the other


Sales

You may place an order for UltraCompare on our site at:

https:// www.ultraedit.com/store/customer/ home.php?cat=268

or you may contact us using the following numbers:

Telephone: (513) 892-8600

Fax: (513) 892-4915

Orders may also be mailed to us at:

IDM Computer Solutions, Inc.

5559 Eureka Dr., Suite B

Hamilton, OH 45011

If you have questions regarding pricing or licensing options please contact us at: sales@idmcomp.com


Technical Support

You can obtain free support for UltraCompare if you've registered and paid for a license.

Free Email Support

For free technical support please email any questions/suggestions to support@idmcomp.com.

Free User-to-User Support Forum

Users may exchange tips and observations in the UltraCompare User's Forum on our site. This is not intended as a replacement for technical support, but many times users can help each other and this can be useful in creating a community of users.


License Agreement - Registered
Previous Topic

END-USER LICENSE AGREEMENT ("EULA")

IDM Computer Solutions, Inc., ("IDM")

IMPORTANT - READ CAREFULLY: This is a legally binding agreement between You and IDM for the use of IDM SOFTWARE PRODUCTS or SOFTWARE.

BY PAYING THE LICENSE FEE FOR THE SOFTWARE PRODUCT YOU AGREE TO BE BOUND BY THE TERMS AND CONDITIONS OF THIS EULA.

U.S. COPYRIGHT LAWS AND INTERNATIONAL COPYRIGHT TREATIES, AS WELL AS OTHER INTELLECTUAL PROPERTY LAWS AND TREATIES PROTECT THE SOFTWARE PRODUCT. IDM IS AND SHALL REMAIN THE OWNER OF ALL INTELLECTUAL PROPERTY RIGHTS IN THE SOFTWARE. THE SOFTWARE PRODUCT IS LICENSED TO YOU ON A NON-EXCLUSIVE, NON-ASSIGNABLE, NON-TRANSFERABLE, LIMITED, PERSONAL BASIS, NOT SOLD.

TERMS:

I. "You" means the person, company, or organization that has licensed the SOFTWARE PRODUCT(s) or SOFTWARE by means of a paid license fee respective of your order.

II. "SOFTWARE PRODUCT or SOFTWARE" means use of a copy of computer software identified herein and any associated media included in Your order. A copy of the printed materials may include "online" or electronic documentation as well as any applicable licensed third party Content.

III. "Computer" means a virtual or physical computer device that accepts information in digital or similar form and manipulates it for specific result based on a sequence of instructions.

IV. "Internal Network" means a private, proprietary network resource accessible only by employees and individual contractors (i.e., temporary employees) of a specific corporation or similar business entity. Internal Network does not include portions of the Internet or any other network community open to the public, such as membership or subscription driven groups, associations and similar organizations.

V. “Territory” means worldwide, but excludes any U.S. embargoed countries and countries where you are prohibited from using the Software or the Services.

1. LICENSE GRANT AND RESTRICTIONS.

The following section applies to all IDM SOFTWARE PRODUCT(S) and SOFTWARE.

If You obtained the SOFTWARE and any required SOFTWARE key(s) from IDM or one of its authorized distributors and as long as You comply with the terms of this EULA, IDM grants You a non-exclusive, non-transferable, limited personal license to install and use the SOFTWARE PRODUCT or SOFTWARE in a manner consistent with its design, documentation, and Your order. You may only use the SOFTWARE according to the License ordered by You and granted by IDM. IDM offers several license types to meet the needs of its customers. Particular licenses are offered for the SOFTWARE PRODUCT OR SOFTWARE depending on the intended use of the SOFTWARE. Your order shall designate the authorized use of the SOFTWARE which may include but is not limited to; Personal License, Concurrent License, Multi License, Site License, Enterprise License, or Volume Discount License.

1.1 General Use. Except as otherwise provided in this EULA, You may install and use the SOFTWARE on up to the Permitted Number of Your compatible Computer(s) according to your order. For Personal licenses (a single license), as long as you are the Sole User of the software, you may install and use the SOFTWARE on up to three compatible Computer(s)

1.2 Distribution from Server. You may copy an image of the SOFTWARE onto file server(s) within Your Internal Network for the purpose of downloading and installing the SOFTWARE onto Computers within the same Internal Network for use as permitted by Section 1.1.

1.3 Server Use. You may install the SOFTWARE on Computer file server(s) within Your Internal Network only for use of the SOFTWARE initiated by an individual from a Computer within the same Internal Network as permitted by Section 1.1. The total number of users (not the concurrent number of users) able to use the SOFTWARE on such Computer file servers(s) may not exceed the Permitted Number of users as specified by the license purchased.

1.3.1 The foregoing does not permit You to install or access (either directly or through commands, data or instructions) the SOFTWARE: (i) from or to a Computer not part of Your Internal Network (with the exception of a world-wide enterprise license), (ii) for enabling web hosted work groups or services available to the public, (iii) by an individual or entity to use, download, copy or otherwise benefit from the functionality of the SOFTWARE unless licensed to do so by IDM, (iv) as a component of a system, work flow or service accessible by more than the Permitted Number of users.

1.4 Backup Copy. You may make a reasonable number of backup copies of the SOFTWARE, provided Your backup copies are not installed or used for other than archival purposes.

2. Subscription-Based Software License (if applicable). If we provide the Software to you as part of your subscription to use the Services, then subject to your compliance with these terms, we grant you a non-exclusive license to install and use the Software: (a) in the Territory, (b) so long as your subscription is valid, and (c) consistent with applicable terms and related documentation of this agreement. For personal subscriptions, you may activate the Software on up to 5 computers (or virtual machines) at a time. If your activations are associated with a License ID for a business, corporation or academic institution, then your activations are limited to the quantity purchased. Personal activations may not be used by anyone other than the individual licensee.

2.1 Activation. The Software may require you to take certain steps to activate your Software or validate your subscription. Failure to activate or register the Software, validate the subscription, or a determination by us of fraudulent or unauthorized use of the Software may result in reduced functionality, inoperability of the Software, or a termination or suspension of the subscription.

2.2 All our subscription plans are Pre-paid

a. Payment. You will be charged the fees stated at the time of purchase. As soon as we have received full payment, your paid subscription will begin.

b. Renewal. The prepaid price is valid for a full 12 months. After that, we'll renew your contract automatically unless you cancel. The price is subject to change, but we will always notify you beforehand.

c. Refund. Because all IDM products are available on a 30-Day Free Trial basis, paid subscription or license fees are not subject to refund.

d. Annual Commitment with Annual Payment. Your credit card will be charged the fees stated at the time of purchase. Your subscription will start as soon as your credit card is successfully charged and will renew automatically until you cancel your subscription. Price may change at the end of your subscription period.

e. Cancellation. The IDM All Access license is offered on an annual pre-paid subscription basis only. We will always send you a renewal notice (even if you have authorized automatic renewals). Once you receive the renewal notice, you may cancel your subscription by clicking through the “MyAccount” link. You may also cancel your subscription by emailing us or by phone.

2.3 Online Purchases. To ensure a safe and secure online shopping experience, IDM uses Avangate as its online checkout merchant service provider. All online transactions are subject to common card industry terms and conditions. These may be found here: http://www.avangate.com/terms.php

3. OTHER RIGHTS AND LIMITATIONS.

3.1 Limitations on Reverse Engineering, De-compilation, and Disassembly. You may not reverse engineer, decompile, translate, localize or disassemble the SOFTWARE PRODUCT.

3.2 Separation of Components. The SOFTWARE PRODUCT is licensed as a single product. Its component parts may not be separated for use on more than one computer. You may not unbundle or repackage the SOFTWARE PRODUCT for distribution.

3.3 Rental. You may not rent, license, assign, transfer, time share, host, lend, sub-license, distribute, or lease the SOFTWARE PRODUCT except as otherwise expressly provided in this EULA.

3.4 Software Transfers of Rights. You may transfer a multi-user, site, or enterprise license (in-full) in connection with a divestiture, a merger, or consolidation, as long as You provide IDM with prior written assigned notice, on a form that IDM will provide You, that includes: (i) the original license order number/details; (ii) the quantity of licenses, if applicable, being transferred by product and version; (iii) the name, address and contact information of the transferee; (iv) any other information that IDM reasonably requests.

For all other transfers of licenses, IDM prior written consent is required. No license transfer will be valid unless the transferee accepts in writing the applicable product use rights, use restrictions, and limitations of liability. Any transfer made in violation of the requirements or restrictions of this section will be void and may result in the license being terminated. You may not transfer licenses on a short-term basis or transfer temporary rights to use products.

The SOFTWARE PRODUCT and any copies of the SOFTWARE PRODUCT or any SOFTWARE key or key codes related to the SOFTWARE PRODUCT and IDM trademarks may not be used, posted or displayed in any form or manner on any online auction sites or any other site without the express prior written permission of IDM.

3.5 Term and Termination. The term of this EULA granted to you for the use of the SOFTWARE PRODUCT is for 1 year, renewable automatically, but without prejudice to any other rights, IDM may terminate this EULA if you fail to comply with any of the terms and conditions of this EULA. In such event, you must destroy all copies of the SOFTWARE PRODUCT and all of its component parts.

3.6 Multi-Platform License (Software for Windows, Mac, Linux operating systems). The SOFTWARE PRODUCT or SOFTWARE, which is the subject matter of this EULA, is for use on a single platform or all three platforms depending on the product your order.

3.7 Educational Version. When we discount the Software or Service as for special use by educational users then we refer to it as an “Educational Version”. You may only use the Educational Version if you meet the eligibility requirements stated at http://www.ultraedit.com/register-buy/edu-discounts.html. You may install and use Educational Version only in the country where you are qualified as an educational user. If you reside in the European Economic Area, then the word “country” in the sentence preceding this one means the European Economic Area.

3.8 Trial Version Restrictions. Your rights to install and use the Trial Version under this section will immediately terminate upon the earlier of (a) the expiration of the Trial Period, or (b) such time that You purchase a license to the SOFTWARE PRODUCT or SOFTWARE. YOU ACKNOWLEDGE THAT THE TRIAL VERSION MAY HAVE LIMITED FEATURES, FUNCTION FOR A LIMITED PERIOD OF TIME, HAVE OTHER LIMITATIONS NOT PRESENT IN A NON-TRIAL VERSION OF THE SOFTWARE. NOTWITHSTANDING ANYTHING TO THE CONTRARY IN THIS EULA, THE TRIAL VERSION OF ANY IDM SOFTWARE PRODUCT or SOFTWARE IS PROVIDED TO YOU ON AN "AS IS" BASIS, AND IDM DISCLAIMS ANY WARRANTY OR LIABILITY OBLIGATIONS TO YOU OF ANY KIND.

3.9. Upgrades. If upgrading from one IDM SOFTWARE PRODUCT to a different IDM SOFTWARE PRODUCT, the subsequent use of the originating product is invalidated/prohibited in accordance with this EULA (Effectively exchanging rights of use). For products purchased with 2 years of upgrades, you will not be charged for any major or minor releases from the date of your order for a period of 24 months. For orders that were purchased with Unlimited Lifetime Upgrades, you will not be charged for any major or minor releases from the date of your order for the life of the product. See also End of Life Policy.

4. Intellectual Property Rights. All rights, title, and interests, including, but not limited to, all copyrights, trade secret rights, patent and trademark rights in and to the SOFTWARE PRODUCT (including but not limited to any images incorporated into the SOFTWARE PRODUCT), the accompanying printed materials, and any copies of the SOFTWARE PRODUCT, are owned by and shall remain the sole property of IDM.

5. Injunctive Relief. The parties agree that if You utilize or otherwise use any of the SOFTWARE PRODUCT in an unauthorized manner, or breach the terms and conditions of this EULA, that such use or breach would have a devastating and serious impact on IDM’s continuing ability to compete profitably and would, therefore, result in immediate and irreparable injury, loss or damage to IDM. The parties agree that in such event, in addition to IDM’s right to recover damages for a breach of this EULA, IDM would be entitled to obtain a temporary restraining order or a preliminary injunction from a court of competent jurisdiction to prevent You, Your employees, agents, consultants, or independent contractors from engaging in any further use of the SOFTWARE PRODUCT or the continued breach of the remaining terms and conditions of this EULA.

6. Limited Warranty. IDM warrants that the SOFTWARE PRODUCT will perform substantially in accordance with the accompanying written materials for a period of ninety (90) days from the date of receipt. Some states and jurisdictions do not allow limitations on duration of an implied warranty, so the above limitation may not apply to You. To the extent allowed by applicable law, implied warranties on the SOFTWARE PRODUCT, are limited to ninety (90) days and one year, respectively.

7. Customer Remedies. IDM’s and its suppliers’ or licensor’s entire liability and Your exclusive remedy shall be, at IDM’s option, either (a) return the license fee paid, or (b) repair or replacement of the SOFTWARE PRODUCT that does not meet IDM’s Limited Warranty and which is returned to IDM with a copy of Your receipt.

This Limited Warranty is void if failure of the SOFTWARE PRODUCT has resulted from misapplication. Any replacement SOFTWARE PRODUCT will be warranted for the remainder of the original warranty period or thirty (30) days, whichever is longer. Outside the United States, neither these remedies nor any product support services offered by IDM are available without proof of purchase from an authorized international source.

8. NO OTHER WARRANTIES. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IDM AND ITS SUPPLIERS, and LICENSORS DISCLAIM ALL OTHER WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

9. NO LIABILITY FOR CONSEQUENTIAL DAMAGES. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT SHALL IDM OR ITS SUPPLIERS, OR LICENSORS, BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS) ARISING OUT OF THE USE, MISUSE, OR INABILITY TO USE THE SOFTWARE PRODUCT, EVEN IF IDM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. BECAUSE SOME STATES AND JURISDICTIONS DO NOT ALLOW THE EXCLUSION OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE ABOVE LIMITATION MAY NOT APPLY TO YOU.

10. Survival. The restrictions and obligations as contained in this EULA which You have voluntarily agreed to shall survive any expiration, termination or cancellation of this EULA, and shall continue and remain in effect to bind You, and Your employees, agents, successors, heirs and assigns.

11. Succession. This EULA and the applicable License restrictions set forth the entire Agreement and understanding between the parties as to the subject matter of this Agreement and supersede all prior EULA's, discussions, representations, and amendments of understandings of every kind and nature between them.

12. Amendments. Except as otherwise provided in this EULA, this Agreement may not be amended, altered, or any of its provisions waived on behalf of either party, except in writing executed by both parties’ duly authorized agent.

13. Assignability. Except as otherwise expressly provided under this EULA, this agreement and the rights and duties under this Agreement may not be assigned by You without the prior written consent of IDM.

14. Benefit. This EULA shall be binding upon and inure to the benefit of IDM and its successors and assigns.

15. Counterparts. This EULA may be executed and/or accepted in one or more counterparts, each of which shall be enforceable against the party actually executing and/or accepting the counterparts, and all of which together shall constitute one instrument.

16. Severability. If any provision of this EULA becomes or is declared by a court of competent jurisdiction to be illegal, unenforceable, or void, the remaining portion(s) of this EULA shall continue in full force and effect without said provision; provided, however, that no such severability shall be effective if it materially changes the economic benefit of the EULA to IDM.

17. Authority to Execute and Accept. You warrant and represent to IDM that this EULA shall be binding upon You, and that the individual agreeing to be bound under the terms and conditions of this EULA is authorized or has been empowered to do so.

18. Third party Acknowledgement and Terms. The SOFTWARE PRODUCT or SOFTWARE may use or include third party components or Content and other copyrighted or publicly licensed material. Acknowledgments, licensing terms and additional disclaimers for such components, Content, or materials are contained in the respective components documentation, and Your use of such components, Content or material is governed by their respective terms and conditions.

19. Order of Precedence. If there is any conflict between the terms of any previous End User License Agreement (EULA) and this Agreement and any Additional Terms, then this agreement and any Additional Terms shall govern in relation to perpetual software licenses and subscription-based Software use.


3-Way Folder Mode

3-Way Folder Mode (Mode menu)

This option allows the user to switch the active compare to a 3-way text comparison regardless of what mode is active at the time this item is selected. For further information please see 3-Way Folder Navigation.


3-Way Folder Navigation

UltraCompare Professional supports comparison of three different directories at the same time if desired. This mode may also be used to compare the content of .zip archives against folders on the file system.

The All, Just Differences, Just Matching [1] buttons allow users to toggle what items are shown in the folder compare and may be used to help focus on desired items in a complex compare. Clicking on the Basic, Full, Smart [4] buttons will change the type of folder compare being executed. When working with multiple text/folder compare sessions at the same time, users may switch between sessions by clicking on the associated Session [8] tabs.

Clicking on the View Next Difference button [2] will position the cursor at the next difference in the active compare and clicking on the View Previous Difference button [3] will position the cursor at the last difference previous to the current cursor position in the active compare. Both give the user an easy method for stepping through differences sequentially without having to manually search them out. These are available for navigation of all compare modes.

Clicking on the Recursive Compare [6] button toggles the "depth" of the folder compare being executed. If this is selected, UltraCompare will compare all subfolders below the specified root and indicate whether the included subfolders are matching or not. If Recursive Compare is not selected, the compare result will display subfolders that exist in the compared folders, but they will not be expanded/compared by default.

Collapsed folders may be expanded by pressing "+" on the numeric keypad and collapsed again by pressing "-" on the numeric keypad. When a folder is expanded its contents will be compared if this has not already occurred based on the active compare. Clicking on the Parent Directory [5] button navigates to the folder above the root directory for folder specified and refreshes the associated trees.

Clicking on any column heading (Name, Status, Date, Size, Type) will sort the result based on the content of that column. Right-clicking on a column heading presents a submenu where the user may select which columns are displayed in a Folder Compare.

The Folder Compare Symbols [7] button displays a dialog that clarifies the meaning of the symbols displayed beside files/folders in the compared trees.

The Status Bar [9] indicates verbally what is shown in the displayed trees for the compared folders along with the summary description (to the far right) of "Different", "Matching", or "Nothing to Compare".


3-Way Difference Navigation

The Go to Next Difference and Go to Previous Difference [1] buttons and Go to Previous Difference Characters and Go to Next Difference Characters [2] buttons on the toolbar and the graphical navigation map [3] shown to the left and right of the compare panes are the primary methods for navigating the differences detected by UltraCompare when files are compared.

Clicking on the Go to Next Difference button [1] will position the cursor at the next difference in the active compare (the pair of files with the highlighted bar between them) and clicking on the Go to Previous Difference button [2] will position the cursor at the last difference previous to the current cursor position in the active compare. Both give the user an easy method for stepping through differences sequentially without having to manually search them out. These are available for navigation of all differences including Text Compares, Binary (smart) Compares, Binary (fast) Compares, and Directory Compares.

The graphical navigation map [3] is displayed to the left and right of the compare panes during a 3-Way Text Compare. By default this is displayed in scrollable mode. If you prefer, you may click on the Scalable Map / Scrollable Map toggle in the View menu to switch to a scalable rather than scrollable navigation map. In this mode the differences are represented for the entirety of both compared files rather than shown as a scrollable map.

Double clicking on the graphical navigation map [3] will position the compared files accordingly. This allows very quick point-to-point navigation within the files rather than sequentially stepping through differences and also presents a quick overview of the number of differences between compared files. The red rectangle displayed within this space represents the visible portion of the files being compared.

If a closer inspection of the contents of one of the compared files is desired, users may click on the Maximize First Pane, Maximize Second Pane, or Maximize Third Pane [6] buttons to automatically maximize the display space for the related pane. Clicking the icon again will restore the related pane to its default size. Where a targeted review of character differences in the active line is desired, users may click the Show Active Line Window [7] button to toggle the display of an additional window highlighting the differences between the lines which have focus in the active compare.

Difference Highlighting

It is important to note that in a 3-way text compare the colors used to highlight the background of the compared frames provide useful information regarding all three files at once, while the information displayed in the status bar [5] and the additional frames applies only to the active pair (indicated by the highlighted vertical bar between frames and the text "Pair [1 - 2]" in the status bar).

Background Color | Meaning
White | data in these sections match in active frames
Blue | data in these sections are different - see symbols below for indicator
Blue Fading to White | data in these sections are different from one compared frame but match the other - this background highlighting would only be seen in Frame 2
Vertical Blue Bars | indicates empty lines (no data, no hard returns) - usually caused by padded lines added to one frame to accommodate data occurring in one file that does not exist in another

Compare Symbol | Meaning
!> | data exists in right frame but not left
<! | data exists in left frame but not right
!! | only empty lines exist here
* | data exists in both frames but is different


3-Way Text Mode

3-Way Text Mode (Mode menu)

This option allows the user to switch the active compare to a 3-way text comparison regardless of what mode is active at the time this item is selected. For further information please see 3-Way Difference Navigation .


About UltraCompare

This command presents the About dialog which shows what version is being run and also indicates whether or not the product is currently registered. If the product is registered the name in which the product is registered will be indicated here.


Active line window

This command enables a full width display of the active lines of each compared file at bottom of application


Advanced Merge

These commands may be used to merge differenced blocks from one file to the other without overwriting the existing content of the receiving file. To achieve this the user specifies whether the text to be merged should be merged above or below the existing text.


All

This option causes all lines in both files to be displayed.


Application Layout

Application Layout (Configuration)

The Application Layout branch under Configuration includes the following options:

Allow multiple instances

If this option is selected multiple instances of UltraCompare may be launched at the same time.

Move to first difference after compare

If this option is selected, the active line/item will automatically move to the first difference in compared items.

Move to next difference after merge

If this option is selected, the active line/item will automatically move to the next difference after a merge occurs.

Use registry for settings (not INI file)

This setting causes the editor to save and retrieve all settings from the registry. After UltraCompare determines the INI file in use it checks for this value before reading any other values. If this is set UltraCompare stores all settings in the registry. If this option is unchecked, all current settings in the registry will be moved to the newly created INI file.

Scan on refresh only

If this option is selected, the folders specified for a folder compare are only scanned when the "refresh" or "go" buttons are pressed.

Show difference summary after compare

If this option is selected, the difference summary will automatically be displayed as soon as the active comparison completes.

Show session tabs at the top

If this option is selected, session tabs will be displayed just below the toolbars rather than below the compare panes.

Append summary to Output Window

If this option is selected, the results of executed file/folder comparisons will be added to the current contents in the Output Window.

Show progress

If selected, this option causes the progress of the active folder compare to be indicated with messages and progress bars in the status bar.


Binary

Binary (Configuration - Compare)

The Binary branch under Configuration - Compare has the following options for Binary Compares:

Decimal offset

If this option is selected the offset displayed for binary compares will be decimal. If this is not selected the offset displayed will be hexadecimal.


Binary

Binary (Configuration - Display)

The Binary branch under Configuration - Display has the following options:

Color and Font Setup

Users may specify color preferences for contrasting colors used for binary compares. Clicking on the colored rectangle by a text label will present a dialog from which the user may select the color to be used for the indicated item.

Load Color Scheme

Two color schemes have been predefined. If desired, users may select between these by choosing one of the options offered in the dropdown.

Font Setup

Pressing the Font Setup button presents the default system Font dialog where the user may define the font to be used for text compares including options to set the font style, size, and script. In Binary (Smart/Fast) Compare mode only monospace fonts may be selected.

The Use Defaults button may be pressed to restore the default colors/font settings for binary compares.


Binary (fast) Mode

This option allows the user to switch the active compare to a byte-by-byte binary comparison (fast) regardless of what mode is active at the time this item is selected.


Binary (smart) Mode

This option allows the user to switch the active compare to a block binary comparison (smart) regardless of what mode is active at the time this item is selected. As opposed to a Binary (fast) Mode comparison which is byte-by-byte, this compare mode will show where there are matching blocks of code even if they are offset by inserted/deleted data and don't match in a byte-by-byte comparison.


Bookmarks

When doing a text compare of files you can right-click on a line and select Add Line to Bookmarks from the context menu to add the active line to the bookmarks list. Multiple bookmarked lines may be added to this list.

Clicking on Bookmarks in the Edit Menu will present a dialog listing the currently specified bookmarks and you may select a line from this list and press the Go To button to jump to the specified line.


Browser View

The Browser View submenu offers "set and forget options", meaning it will not change any views on its own. The available options are Current, Other, and External. The toolbar button Show In Browser may also be used to invoke the Browser View function. This may be used for two-way and three-way compare modes.

If F12 or the Show In Browser toolbar button is pressed and Current is selected then the browser view will be displayed for the active frame. This allows the user to open a browser view for each frame. Each frame’s browser view would represent the content of that frame.

If Browser View is invoked and Other is selected then the browser view will be displayed within the "non-active" frame. This would allow the users to see source code and HTML representation side-by-side. For three-way compare mode the “other” window will always be the secondary compare window. The merge abilities for the primary compare windows are available in Other mode ONLY during a three-way compare.

If Browser View is invoked and External is selected then the content of the active view will come up in the users preferred browser. This mode does not have a secondary effect if F12 or the Show File In Browser toolbar button is pressed again. Therefore, for each press of the F12 key or the toolbar button a new browser window would appear, or browser tab if the browser supports tabbed browsing.


Center on Difference

This command repositions the displayed files such that the current difference is centered.


Columns

Columns (Configuration - Display - Folder)

The Columns branch under Configuration - Display - Folder has the following options:

Synced width changing

When this option is selected and columns are resized in one pane of a folder compare, the matching column in the other pane(s) will automatically be resized accordingly.

Automatically resize columns to fit the contents

When this option is selected and a compare is executed, the columns will automatically be resized to fully display the largest members of the active columns.


Columns

Columns (Configuration - Find Duplicates)

The Columns branch under Configuration - Find Duplicates has options which control which data columns are shown in the Results Report after running a Find Duplicates scan. The following options are available:

- Path

- Size

- Date Created

- Date Modified

- Attributes

- Version


Compare Column Ranges

When the Compare Column Ranges command is selected the Compare Column Ranges dialog is presented. Users may enter up to four ranges separated by semi-colons. For example, a user could enter ‘1-5; 7-10’. If the user presses the ‘OK’ button the menu item is checked. UltraCompare will only compare columns with the range of 1-5 and 7-10 ignoring everything else. A difference would only be indicated within the bounds of these ranges. All other columns would be ignored and would therefore be represented by a non-difference background. Selecting the menu item a second time disables this comparison. UltraCompare will remember the last ranges entered.

Please note: The options to Compare/Ignore Column Ranges are exclusive (i.e. only one may be selected at a time).


Configuration Summary

When Configuration is selected in the Options menu, a Configuration dialog is presented with configuration options divided by category. These may be easily navigated using the index tree to the left of the dialog.

To read about what each setting does, please click on the Contents page in the Help and double click on Menu Commands and then double click on the Options menu and double click on Configuration. This will open a mirror of the index tree in the configuration dialog in the Help files. Users may expand the major sections in the Help:

Compare

Ignore Options

Sessions

Display

Application Layout

File Handling

Backup & Save

Toolbars/Menus

Key Mapping

Shell Integration

UE/UES Integration

Double-clicking on a heading and clicking on the topics included below will provide summaries of the associated options.


Context Menu Options

The context menu in UltraCompare offers some very useful features for file management, merging of differences, and directory navigation in both the text compare modes and the folder compare mode.

The following commands are available in Text Compare mode:

Open in UltraEdit | opens selected files in UltraEdit for editing
Align Manually | resets alignment based on the two lines currently selected in the active file compare - must be invoked separately in both compare panes to set lines for manual alignment. After the second line is selected for manual alignment, all lines above those selected will be marked in the line number column to indicate that they are not included in the active compare.
Reset Alignment | restores compared file alignment to default scan state
Merge First to Second | merges selection from left file to right file
Merge Second to First | merges selection from right file to left file
Advanced Merge | merges selection from left to right (or right to left) either above or below the differenced line without overwriting the existing text
Accept All | accepts all merge changes in specified files
Cut | deletes selection from active document and moves it to the clipboard
Copy | copies selection from active document to the clipboard
Copy Frame to Clipboard | copies content of active frame to clipboard obeying filters if applied
Paste | pastes data from the clipboard into active document
Delete File | deletes active file from disk
Clear | clears the contents of the active compare pane
Delete Selected Line | deletes selected line only in the file in which it is selected
Add Line to Bookmarks | adds the selected line to the current bookmark navigation list
Explore First Folder | opens Explorer to Source directory
Explore Second Folder | opens Explorer to Destination directory
Show File in Browser | passes active file to default browser for OS
Refresh | repeats compare to refresh differences indicated

In Binary (smart or fast) Compare mode, only the Open file in UltraEdit, Delete File, Explore First/Second Folder, Show File in Browser, and Refresh options are available in the context menu.

The following commands are available in Folder Compare mode:

Open in UltraEdit | opens selected files in UltraEdit for editing
Merge First to Second | merges selected file from left to right directory
Merge Second to First | merges selected file from right to left directory
Accept All | accepts all merge changes in specified files
Mark | adds selected files/folders to internal tracking list to support hiding
Reset Marked | removes files/folders from internal tracking list
Hide Marked | hides items added to internal tracking list
Show Hidden | restores visibility of items previously hidden
Delete selected files(s)/folder(s) | removes the selected files/folders from the active directory
Explore First Folder | opens Explorer to Source directory
Explore Second Folder | opens Explorer to Destination directory
Show Preview File | toggles visibility of text file preview of active file in compare
Load First File | presents submenu to select frame to load selected file for text comparison
Show File in Browser | passes active file to default browser for OS
Refresh | repeats compare to refresh differences indicated

The following commands are available in 3-Way Folder Compare mode:

Open in UltraEdit | opens selected files in UltraEdit for editing
Merge First to Second | merges selected file from first to second directory
Merge Second to First | merges selected file from second to first directory
Merge Second to Third | merges selected file from second to third directory
Merge Third to Second | merges selected file from third to second directory
Merge First to Third | merges selected file from first to third directory
Merge Third to First | merges selected file from third to first directory
Accept All | accepts all merge changes specified
Mark | adds selected files/folders to internal tracking list to support hiding
Reset Marked | removes files/folders to internal tracking list
Hide Marked | hides items added to internal tracking list
Show Hidden | restores visibility of items previously hidden
Delete Selected File(s)/Folders(s) | removes the selected files/folders from the active directory
Explore First Folder | opens Explorer to first directory
Explore Second Folder | opens Explorer to second directory
Explore Third Folder | opens Explorer to third directory
Show Exclude Dialog | presents dialog where user may select files/folders to exclude from active compare
Show Preview File | toggles visibility of text file preview of active file in compare
Refresh | repeats compare to refresh differences indicated


Create Backup File

Create Backup Files

This command may be used to create a backup of the compared files. This is suggested prior to repeated merge commands so that a "baseline" file is maintained to restore if necessary.


Customization

Customization (Configuration - Toolbars/Menus)

The Customization branch under Configuration - Toolbars/Menus has the following options:

Customize Toolbars/Menus

Pressing this button presents the Toolbar/Menu Configuration dialog which consists of two panes labeled Toolbars and Commands.

Toolbars/Commands Configuration Panes

The toolbars which have been specified are displayed in the Toolbars pane. Checking and unchecking the box the left of a toolbar name will reveal and hide that toolbar.

The Commands pane displays all the functions currently available for use in the toolbars and menus. To move an item from the Commands pane to a Toolbar or menu, drag to the desired location.

New Toolbars

To create a new toolbar, switch to the Toolbars pane and click New. Type the toolbar name (i.e. "Test1") in the New Toolbar field and click OK. A new, empty toolbar will appear over the configuration dialog. Drag it to the desired location.


Decimal Offset

This option changes the offset values displayed to the left of the compare panes to be changed from HEX mode to decimal mode


Show Output Window

This command displays the Output Window containing different data depending on the type of compare in progress. During a Text Compare this would summarize the number of blocks and lines that are different between the two files being compared. During a Folder Compare the resulting dialog would summarize file and subdirectory differences in compared folders.

Right clicking in the Output Window displays a context menu with the following options:

Hide Output Window | hides Output Window
Clear Output: Active Session | clears the contents of the Output Window for the active session only
Clear Output: All Sessions | clears the contents of the Output Window for all sessions
Copy to Clipboard | copies the contents of the Output Window for the active session to the clipboard
Scroll Output | controls whether output window focus scrolls to last line when populated or remains at the current line


Diffs only

This option may be selected to display only lines, files, or folders containing differences. This can be useful in the process of comparison and merging.


Folder Mode

This option allows the user to switch from the active file compare mode (Text, Fast/Smart Binary) to Directory mode. This will initially present an empty compare and any active file compare will be terminated. This mode allows users to compare the content of .jar, .rar and .zip archives as well as folders on the file system.


Edit in UltraEdit

This command opens the files currently active in a Text Compare in UltraEdit for editing.


Edit Menu

The Edit menu offers the following commands:

Next Difference | repositions to the next difference in the compared files
Previous Difference | repositions to the previous difference in the compared files
Next Difference Characters | repositions to the next difference in the differenced block
Previous Difference Characters | repositions to the previous difference in the differenced block
Find | searches for specified string in active file
Go to Line/Column | repositions cursor to specified line/column in both files
Cut | deletes data from active document and moves it to the clipboard
Copy | copies data from active document to the clipboard
Copy Frame To Clipboard | copies content of active frame to clipboard obeying filters if applied
Paste | pastes data from the clipboard into the document
Delete Selected Line | removes the selected line from the active file
Delete Selected File(s)/ Folder(s) | removes the selected files/folders from the active directory
Bookmarks | presents dialog box showing bookmarked lines for navigation
Add Bookmark | highlights line number and bookmarks active line in active file
Delete Bookmark | removes bookmark for selected line


Explorer & sessions

This command displays the Explorer & Sessions dialog including the Explorer and Sessions panes


Specify Binary Extensions

Specify Extensions (Options menu)

This command presents the Specify Extensions dialog in which the user may specify extensions and descriptions for files that UltraCompare should interpret as text or binary files. UltraCompare attempts to determine the proper mode for files, but in some instances users may need to specify which mode should be used.

There is a list of file types listed by default and users may remove items from this list or add to it as needed.


Favorites

This command presents a dialog where frequently used directories and files may be specified. The full path for a directory or file may be manually typed in the textbox below the list pane or the Browse button may be used to browse to desired directories or files. Once a path has been entered/selected, pressing the Add button will add the specified path to the Favorite Files/Directories list for future use and you may press Open as Source or Open as Destination to open the specified directory or file in the desired pane.

Also, if currently comparing directories or files that you wish to add to the list, you may press the Add Source or Add Destination buttons to add active compare items to the Favorite Files/Directories list.


File Handling

File Handling (Configuration)

The File Handling branch under Configuration includes the following options:

File change detection

If this option is selected UltraCompare will automatically poll for changes in compared files and allow the user to update the file.

Secure delete with UltraSentry

If this option is selected, specified files/folders may be securely deleted with UltraSentry. This option will be subdued if UltraSentry is not detected as installed. Users may specify the secure delete level to be used for secure deletion in the accompanying dropdown.

Prompt when file/folder in file history does not exist

If this option is selected and a previously used file/folder path which no longer exists is selected from the address bar dropdown, a prompt dialog will be displayed to notify the user that the selected item cannot be found.

Prompt when file/folder path typed in address bar does not exist

If this option is selected and the user types an invalid file/folder path in the address bar, a prompt dialog will be displayed to notify the user that the selected item cannot be found.


File Menu

The File menu offers the following commands during a text/binary/folder compare:

Open First | invokes File Open dialog to specify file to be opened in Source pane
Open Second | invokes File Open dialog to specify file to be opened in Destination pane
Find Duplicates | invokes Find Duplicates dialog
Save As | saves the contents of the active pane to the specified file name
Close All Files | closes all opened documents
FTP - Open from FTP | opens an existing document from an FTP site
FTP - Save As to FTP | saves an opened document to a specified file name on an FTP site
Favorites | presents a dialog for specifying most-used compare directories
Save Merged Changes | saves changes made during previous Merge operations
Save Result | saves the result summary of the active compare as a text file
Print Preview | displays the result summary onscreen as it would appear printed
Print Setup/Configuration | displays Page Setup dialog for configuring print settings
Print | prints the result summary
Print First | prints the left file only
Print Second | prints the right file only
Preview First | displays the left file onscreen as it would appear printed
Preview Second | displays the right file onscreen as it would appear printed
Exit | exits UltraCompare

The File menu offers the following commands during a 3-way text compare:

Open First | invokes File Open dialog to specify file to be opened in Frame 1 pane
Open Second | invokes File Open dialog to specify file to be opened in Frame 2 pane
Open Third | invokes File Open dialog to specify file to be opened in Frame 3 pane
Find Duplicates | invokes Find Duplicates dialog
Save As | saves the contents of the active pane to the specified file name
Close All Files | closes all opened documents
FTP - Open from FTP | opens an existing document from an FTP site
FTP - Save As to FTP | saves an opened document to a specified file name on an FTP site
Favorites | presents a dialog for specifying most-used compare directories
Save Merged Changes | saves changes made during previous Merge operations
Save Result | saves the result summary of the active compare as a text file
Print Preview | displays the result summary onscreen as it would appear printed
Print Setup/Configuration | displays Page Setup dialog for configuring print settings
Print | prints the result summary
Print First | prints Frame 1 file only
Print Second | prints Frame 2 file only
Print Third | prints Frame 3 file only
Preview First | displays Frame 1 file onscreen as it would appear printed
Preview Second | displays Frame 2 file onscreen as it would appear printed
Preview Third | displays Frame 3 file onscreen as it would appear printed
Exit | exits UltraCompare


Find

The Find command presents the Find dialog in which the user may specify a search string which UltraCompare will attempt to match in the active file. This dialog includes the options "Match whole word only" and "Match case" as well as a direction option allowing the user to specify whether UltraCompare should search upward or downward in the active file for the specified string.


Find Duplicates

Note: If UltraFinder is installed, it will be launched instead.

This command allows a user to locate duplicate files on their system and then delete unwanted duplicates. Using the Criteria Settings users can easily search for single files or all duplicate files within a folder. Once the search has finished the results are shown in the Results Report window. Duplicates are listed by groups and each group has a separate listing of all duplicate files in the group. Each duplicate file entry contains pertinent file metrics (path, size, date, modified time, etc.). Users can interact with the duplicate file list to delete or rename these files. In addition to this users may interact with the file listing through context menu commands to further narrow the search results.

The Find Duplicates dialog consists of a tabbed interface with two tabs: Search Criteria and Results Report. The Results Report may be resized to allow easier reviewing of Duplicate Files listing.

Search Criteria

Find Duplicates searches through folders the user specifies to do two things:

1. Discover any files inside the specified folders

2. Compare the files against each other to determine which files are duplicates of one another.

Users configure the search by setting the parameters in the Search Criteria tab. Searches are created by adding folders to search, selecting criteria for matching files, specifying files/folders to exclude from the search and selecting other special properties to ignore.

Folders to Search

In this field the user defines the folder paths to search. Users may either manually type a path or use the browse or ftp open buttons beside it to select the paths to be added to the search list. When the Find Duplicates dialog is launched from an active folder session, the active paths are automatically added to the search list.

Criteria Settings

A duplicate criteria is a “rule” or “metric” that the files must match in order to be considered as “matching” one another. For example, you may want to find files with the same name but not the same size. This area provides access to the criteria options in a form similar to what is done in the application’s configuration dialog.

Options that refine the focus of the primary duplicate criteria options are displayed to the right when a criteria option has focus. Each entry is enabled using the check box next to its name. When a box is checked that criteria is used in the search. Each criterion has options that help control its specificity.

When a duplicate option is selected its associated options are then displayed on the right. Users must select Name, Size or Content in order to execute a search. Name is selected by default. The following options and their associated settings are available:

Name | files must have same name. If desired, Ignore Case and Ignore File Extensions may be specified when evaluating file names.
Size | files must have same size. If desired, users may specify min/max file sizes. If Min File Size is not selected then the search will have a floor of 0 KB. If Max File Size is not selected then the search will have an unlimited file size ceiling.
Dates | files must have same creation and/or modified dates. If Date Created is selected creation dates must match. If Date Modified is selected modified dates must match.
Content | file content must be the same based on a fast binary compare

Ignore Options

Ignore options provide the user with options for specifying files and folders to skip in the search. The following options are available:

Advanced - the following advanced ignore options are available:

Ignore Zero Byte Files | ignores files of zero size
Ignore System Files | ignores system files created by the OS (.sys files)
Ignore Hidden Files | ignores files hidden by OS
Ignore Windows Files | ignores Windows system folders
Ignore Files in the Recycle Bin | ignores any files in the Recycle Bin
Ignore Sub Folders | search will be limited to the top level of the specified search folders

Include Filter

Here the user specifies a list of specific files and/or file filters to which the search should be limited. For example, “*.tmp” means the search would skip any file WITHOUT the .tmp extension. File names and wildcards are entered in the edit box and added with the Add button. The Delete button removes them.

Exclude Filter

Here the user specifies a list of specific files and/or file filters to exclude from the search. For example, “*.tmp” means the search would skip any file WITH the .tmp extension. Files names and wildcards are entered in the edit box and added with the Add button. The Delete button removes them.

Exclude Folders

Here the user specifies a list of specific folders and/or folder filters to exclude from the search. For example, if “Folder1” is in the search folder it would be skipped. If “*svn” were used, any folder with svn at the end of the name would be skipped. Folder names and wildcards are entered in the edit box and added with the Add button. The Delete button removes them.

Start

Pressing this button starts the search. When the search runs this button changes to Pause and the main tab is switched to the Results Report and the progress bar is made visible. When a search is not running the progress bar is not shown and the Start button is visible.

Pause

This button pauses the search. When pause is hit the button changes to Continue. This is useful for users who may need to momentarily halt the search for various reasons.

Cancel Search

This button completely cancels the search. This is for users who want to totally halt the search and free up any system resources it is using.

The Close button closes the dialog. This also cancels the search if there is one in progress.

Results Report

The Results Report tab displays the duplicate groups and the list of duplicate files for the selected group. The Results Report tab allows the user to inspect duplicates, rename duplicates, delete duplicates, modify the Search Criteria using context menu commands and launch compare sessions to compare duplicates. The Results Report includes the duplicate groups list on the left hand side, the currently selected group’s file listing on the right hand side and controls for removing the duplicates at the bottom. All other actions are accessed through the context menu.

Duplicates Found

This is a listing of the groups of duplicates. This displays the name of the group and the number of duplicates in the group. This is shown as the group name followed by a number in parentheses - for example, “Test.txt(4)” . If Name is used as a search criterion, the name of the group will be the name of the file. So if a search finds that for “test.txt” there are four other copies, for “abc.txt” there are ten other copies and for “screenshot.png” there are three copies, the following entries would appear: “test.txt (4)”, “abc.txt (10)” and “screenshot.png (3)”.

If Name is not in use and Size is used, then the size will become the name of the groups and the tag <Size> will appear before the group name to clarify against what criteria the group was named. If there are three files that are 102 kb and two files with 1.0 MB the following entries would appear: <Size> 102 kb (3) and <Size> 1.0 MB (2).

If only Content was used as a search criterion then the groups will be given default names, for example <Content> Group1(#), <Content> Group2(#) etc.

When a search is run the files can be narrowed down by name first, size second, date third and then finally content. This is to reduce the search time by reducing the number of date and content compares. Selecting a group in this list will display the entries in the Duplicates Locations list

Duplicates Locations

This is a list with entries for each duplicate file in the group. The data is displayed in columns. What columns are displayed can be changed under the context menu that appears when users right click on the column headers. Column widths can be altered through directly resizing the columns in the list control. The following columns may be displayed:

Path | Contains the full path of the duplicate file
Size | shown in bytes, KB, MB, GB where applicable
Date Created | displayed in the format chosen in Configuration?Find Duplicates?Date Format
Date Modified | displayed in the format chosen in Configuration?Find Duplicates?Date Format
Attributes | An 8 character string is displayed to represent the attribute bit listing in the “ - - a - - - - -“ style format. Format: 1 - reserved 2 - reserved 3 a -> archive 4 d -> subdirectory 5 v -> volume label 6 s -> system file 7 h -> hidden 8 r -> read only
Version | shown in the same format as is found on the File Properties dialog

Each entry in the Duplicates Locations list has a check box. When the user executes a delete the items selected will be moved to the Recycle Bin.

Right clicking an item opens a context menu with the following options:

Compare Selected | if two or three files are selected this option will be enabled. When executed it will start a new compare session to compare the files selected.
Open | sends a command to the OS to open the selected file in its default program
Open in UE/UES | opens the file in UltraEdit or UEStudio depending on what is installed
Rename | initiates renaming of the selected file. Editing is done via the Name column in the list control. The new name is immediately applied to the file when done.
File Properties | opens the OS’s File Properties dialog for the selected file
Open Containing Folder | opens Explorer displaying the containing folder for the item selected
Check | checks the selected file(s) for removal. When the user hits the Delete Checked button then the checked items are sent to the Recycle Bin
Uncheck | unchecks the selected file(s)
Delete | this moves the checked files into the Recycle Bin
Add Selected to Exclude List | adds the currently selected file(s) to the exclude list and causes the Results Report display to update the results with this change
Exclude all Files with this Extension | adds the currently selected file’s extension to the exclude list, it causes the Results Report display to update the results with this change
Exclude Containing Folder | in the Results Report this adds the selected file’s containing folder to the Folder Exclude List. This causes the results to be updated with this change

Multiple files may be selected in the Duplicates Locations listing by using the mouse and CTRL or SHIFT keys. This allows users to apply context menu options to multiple files in the listing at the same time.


Flip Frames

This option will cause the file displayed in the Source (left) pane to be displayed in the Destination (right) pane and vice versa. For presentation purposes users may choose to switch the initial presentation of the compared files.

If a 3-Way Text Compare is active, users will be presented with three options to switch the files represented in specified frames: Flip Frames First <--> Second, Flip Second <--> Third, and Flip First <--> Third.


Folder

Folder (Configuration - Compare)

The Folder branch under Configuration - Compare has the following options for Folder Compares:

Compare Method

Three compare options are available for Folder Mode:

Basic

If this option is selected a Folder Compare will only check the size and date of items included in compared folders.

Full

If this option is selected a Folder Compare will perform a byte-by-byte comparison of all files in compared folders.

Smart

If this option is selected a Folder Compare will include a text compare of all files included in compared folders and will also obey ignore options configured for text compares.

Recursive Compare

If this option is selected compares will include all subdirectories of folders specified for compare rather than just the top level directory.

Force load files in Text Mode

If this option is selected all files will be loaded as text files regardless of their content.

Remember compare mode for file extensions

If this option is selected the last mode used for a given extension determines the mode that will be used the next time a file with the same extension is opened for compare.

Force load undetected files in specified mode

When selected, two radio button options are available: Text Mode and Binary Mode. If this option is selected and UltraCompare cannot determine whether a file is a text file or a binary file when initially loading files for compare, UltraCompare will default to the option specified.


Folder

Folder (Configuration - Display)

The Folder branch under Configuration - Display has the following options:

Color and Font Setup

Users may specify color preferences for contrasting colors used for folder compares. Clicking on the colored rectangle by a text label will present a dialog from which the user may select the color to be used for the indicated item.

Load Color Scheme

Two color schemes have been predefined. If desired, users may select between these by choosing one of the options offered in the dropdown.

Font Setup

Pressing the Font Setup button presents the default system Font dialog where the user may define the font to be used for folder compares including options to set the font style, size, and script.

The Use Defaults button may be pressed to restore the default colors/font settings for folder compares.


Folder

Folder (Configuration - Ignore Options)

The Folder branch under Configuration - Ignore Options has the following options:

Ignore folders/file types

The Ignore folders/file types entry field allows users to add a semi-colon delimited list of folders, files, and file extensions to be ignored in Folder Compare Mode. For example, a user may enter ‘CVS’ and any time the file or folder CVS is located in a folder it will be ignored when executing and displaying a folder compare.

Users may also enter an absolute path to a file/folder to be ignored. An asterisk (*) can be used as a wild card. In order to ignore all files of a particular type the asterisk will be used with the file extension. For example, a user may enter the line ‘*.txt;*.php;*.asm’ and the file extensions .txt, .php, and .asm will be ignored when executing and displaying a folder compare.

Ignore timestamp differences

This option instructs the compare to ignore the file/folder timestamps when identifying differences in the active files/folders. This setting is only available for folder mode compares when the Basic compare method is selected as the Full and Smart methods must check size and timestamp of files in order to function properly.


Folder Synchronization

Folder Synchronization (Configuration - Compare)

The Folder Synchronization branch under Configuration - Compare has the following options:

Show Sync Log in Output Window

If this option is selected, when the Sync is run each file delete and copy operation is listed in the output window. Any errors encountered are listed there as well.

Copy file permissions

If this option is selected it causes file permissions to be copied over when the file is on an NTFS volume. If not selected, it sets default security attributes.

Copy file dates

If this option is select, when a copy is made this will set the create/access/modified dates to what was originally set for the file.

Warn when changing a folder's action will change action for subfolders and files

If this option is selected, and the user changes the action configured for a folder, a warning will be displayed indicating that changing a folder's action setting will apply the same action setting to all the files and folders it contains.

Warn when changing a parent folder's action

If this option is selected, and the user changes the action configured for a file or folder within a parent folder, a warning will be displayed indicating that changing this action will also change the action associated with the parent folder.

Show re-sync confirmation after rules are changed

If this option is selected and a synchronization rule is changed after a synchronization scan has been run, the user is prompted to run the scan again before continuing.

Rules settings

Select rule

Using this dropdown, users may set the rule that will automatically be selected when new sessions are created.

Customize Rules

When pressed this will cause the Rules Customization dialog to be displayed.

Reset Default Rules

When pressed this will reset the default rule set. This is for users who may have altered the rule set.


FTP

FTP (Configuration)

The FTP branch under Configuration has the following options:

Store FTP accounts and settings in user selected file

This option may be used to allow the user to specify a file which will be used to store FTP account options. The user may define this directly in the provided textbox or browse to select a file that already exists. If this option is not selected, FTP account information will be stored as usual.

Display FTP accounts in explorer view

If this option is selected, FTP accounts will be shown in the Workspace Manager under the Explorer tab. The root of the account will be listed as a top level directory and may be expanded to show files/folders under this account.

Show FTP log in output window

If this option is selected an FTP log showing all commands sent to and data received from the FTP server will be displayed in the output window. This can provide helpful diagnostic information and the contents of this window may be copied using the clipboard. When this option is selected, Append summary to Output Window should also be selected under the Application Layout branch in Configuration. If this is not selected, the FTP log will be replaced with the compare results when the files loaded via FTP are compared.

Share FTP Accounts

If this option is selected, the option Store FTP accounts and settings in user selected file will automatically become subdued. When this option is selected, FTP account information is written to a new file IdmFTPAccounts.txt created under %APPDATA%\IDMComp\Common\FTP Accounts. This will allow UltraEdit, UEStudio, and UltraCompare Professional to access FTP account information maintained in a common file rather than storing this information separately for each application.

Use CRC compare for FTP files

If this option is selected, rather than downloading files for local comparison, UltraCompare will attempt to get a CRC value for the specified files from the FTP server using the commands CRC32, MD5 and SHA1. If none of these commands are supported by the remote server, a dialog will inform the user of this and the folder compare will be executed defaulting to the currently selected folder mode compare option.

Prompt when FTP server does not support CRC

If this option is selected and a CRC compare is executed against folders on an FTP server, but that server does not support the commands used for calculating CRC values, a prompt dialog will be displayed to notify the user that the selected folders will be downloaded and the last used folder compare method will be used to compare the specified folders.


FTP Accounts Dialog

This dialog allows user FTP accounts to be configured. The accounts are used for FTP Open and FTP Save As commands.

An account specifies the server to be connected to and the user identification that will be used to connect to the server.

The Add Account button allows you to specify a new account name. The account to modify may be selected from the list of accounts. If any changes have been made to the account a prompt will be shown asking if the changes should be kept.

The Remove Account button immediately removes the active/selected account from the accounts list.

The Set Default Account button sets the active/selected account as the default account specified by an asterisk "*" following the account name in the list.

The FTP Account Manager has options organized under five different tabs: General, Server, Advanced, Proxy, and SSH/SSL.

The General tab includes the following configuration options:

Account

This is the name to be used for the configured account. This name will appear in the list to the left of the configuration options when changes are saved.

Protocol

This dropdown allows users to select one of the following transfer protocols for the account being specified:

FTP | Creates a non-secure FTP connection.
SFTP | Creates a secure FTP (SFTP) connection with the SSH2 protocol.
FTPS - Control Only | Creates a secure FTP (FTPS) connection with an SSL layer below the standard FTP protocol. This method encrypts the control channel ONLY.
FTPS - Control + Data | Creates a secure FTP (FTPS) connection with an SSL layer below the standard FTP protocol. This method encrypts both the control and the data channels.
FTPS - Implicit | Creates a secure FTP (FTPS) connection with an SSL layer below the standard FTP protocol. This is an older FTPS method and is not generally preferred, but is still supported on some servers.

All SFTP/FTPS transfers are encrypted and the encryption algorithm is negotiated with the server. If any of these are set the transfer dialogs will show a "lock" symbol indicating the transfer is secure.

Server

This is the ftp site that you wish to connect to such as ftp:// ftp.idmcomp.com. This may also be entered as ftp.idmcomp.com. If preferred the IP Address in the form xxxx.xxxx.xxxx.xxxx may be entered.

Port

This is the port used by UltraEdit/UEStudio for the FTP/SFTP protocol. The default is 21 for FTP and 22 for SFTP. This may be changed if required.

Username

This is the username used to log into the server.

Password

This is the password used with the username to log into the server. This should be the password for the username as provided by the site administration, or for anonymous log in this is typically the email address of the user.

Save Password

This checkbox determines if UltraEdit/UEStudio will save the password for later reference. If not, the user will be prompted for the password as required. Note: if the password is saved it is stored on the system. It is encrypted however, the encryption mechanism is unsophisticated and should not be relied upon as a method of security.

No Password

If an account does not have a password on the server and should be sent a blank or null password, the No Password option must be enabled.

User Account

This allows the user to specify an account on the host server when logging. This is only required with some servers.

Connection Limit

This setting limits the number of concurrent connections that the FTP client will make with the server. For example, if a user selects 10 files to open or save via FTP, but has the connection limit set to 4, the selected files would be transferred in blocks of 4 or less until all selected files are transferred.

Initial Directory

This is the initial directory to connect to on the FTP server. This is not required. If this is NOT specified, UltraEdit will remember the last directory for the account each time the user connects to the server.

Initial Local Directory

This is the initial local directory used when connecting to the FTP server. This is only used with the FTP Browse option. This is not required. If this is NOT specified, UltraEdit will default to the user's document folder (e.g. My Documents on Windows XP and Documents on Windows Vista).

The Server tab includes the following configuration options:

Server Type

For most FTP servers the default Auto or Unix should work without problem. However this provides for connection to servers that need special handling. The list of servers supported is expected to grow. Currently supported are:

Auto

AIX

VAX/ VMS

UNIX

AIX

Stratus VOS - The "Full Path Leading Character" should be set to "%" and the "Path/Node Separator Character" should be set to ">".

File Name Only - this takes the first field returned and displays it as the filename

BS2000

MVS

OS9000

AS400

HP3000/VeSoft Security

Tandem Guardian

Session Name

This field may be used to define the Session Name for the active account. This is only used for HP3000 accounts.

Send After Login

Any value entered in this field will be passed to the FTP server immediately following connection to the server.

LIST Command Filter

The LIST Command Filter determines what is retrieved from the server when a LIST command is issued. On most FTP servers if you pass "-al" you will receive a full listing including hidden files. You can also pass wildcards. For example "*.txt" would list all txt files. Note that some servers (VMS, MVS, etc) do not handle filter arguments like Unix/Linux servers.

Full Path Leading Character

This allows the user to override the leading character (normally "/") for the full path of a file on the server.

Path/Node Separator Character

This allows the user to override the character (normally "/") used between directories/nodes on the server.

Name Index

This field is used to specify the column number where the name of the file is stored. The default for this value is "-1" and this should not be changed unless you're sure of the value that should be used.

Size Index

This field is used to specify the column number where the size of the file is stored. The default for this value is "-1" and this should not be changed unless you're sure of the value that should be used.

Use MDTM and SIZE

If the modified time and size of files does not appear to be returned correctly this option may be selected to force these values to be explicitly requested for every file returned in the directory listing. Selecting this will likely slow down FTP processes.

Passive Transfers

Because FTP is a port-hopping protocol (i.e. data channels use a random port chosen during the communication), many firewalls have the ability to understand the FTP protocol and allow the secondary data connections. However if the control connection is encrypted using any method the firewall is not able to get the port numbers of the data connections from the control connection (since it is encrypted and the firewall cannot decrypt it). Therefore in many firewalled networks clear FTP connections will work while SFTP/FTPS connections will either completely fail or require the use of passive mode.

Use IP address returned by server

This value is only used when the Passive Transfer option is selected. Selecting this option forces the account to use the IP Address specified by the firewall when connecting to the server. Please note: If you do not control the server you're connecting to or are not sure of its content, there is a security risk involved in selecting this option.

The Advanced tab includes the following configuration options:

Local Copy Directory

This allows the user to specify where a local copy of the file should be saved automatically when a file is saved. If this is blank no local copy is made. If this is not empty, when an FTP Save occurs (not Save As) a copy of the file is saved in the specified directory. If another file exists with the same name it will be overwritten without warning. The local copy is made prior to the FTP Save.

Cache password for session if not saved

If this is checked the password for the account once entered is cached for the period UltraEdit is running and will not need to be re-entered. If the password is entered incorrectly and needs to be changed entering the Accounts dialog and leaving it will clear out the cache.

Default Transfer Type

Users may specify ASCII or Binary as the default transfer type. ASCII causes the file to be appropriately converted for line terminations between different systems. Binary causes files to be transferred byte-for-byte with no conversion. Depending on the FTP server/client, an ASCII transfer may corrupt the file as this is a 7-bit transfer. For this reason, Binary is the preferred transfer type.

Display Filter

Two options exist for filtering the directory listing returned after connecting to the FTP server:

Remote - Use LIST command

If this option is selected, filtering of the directory listing returned from the FTP server will be executed on the FTP server using the LIST command. Results may be filtered using standard wildcards. For example "*.txt" would list all txt files. Note that some servers (VMS, MVS, etc) do not handle filter arguments like Unix/Linux servers.

Local - Perl regular expressions

If this option is selected, filtering of the directory listing returned from the FTP server will be executed on the local system and is only a parsing of the data returned from the FTP server as reflected in the FTP log. This option will use Perl regular expressions to determine how the filter expression should be parsed and what data should be returned.

The Proxy tab includes the following configuration options:

Use Proxy

This enables the proxy settings and configures this account to connect through the specified proxy. If connecting directly to the Internet the proxy settings should not be enabled. If connecting via a proxy on a LAN it will be necessary to set up the proxy settings.

Proxy Server

This is the name of the server (or IP address) that is used for the proxy. If you do not know this name check with your system administrator.

Proxy Port

This is the port used by UltraEdit/UEStudio for the FTP/SFTP protocol. The default is 21 for FTP and 22 for SFTP. This may be changed if required.

Proxy User

This is the username to be used to log into the proxy. If you do not know this name check with your system administrator.

Proxy Password

This is the password to be used to log into the proxy. If you do not know this name check with your system administrator.

Proxy Type

This dropdown is used to specify the type of proxy being used for the current FTP account. The following proxy types are currently supported:

SOCKS4

SOCKS4A

SOCKS5

WEB Proxy

Relay

Windows (Internet Explorer)

FTP User

FTP Site

FTP Open

Please note that not all proxies are available for each protocol.

The SSH/SSL tab includes the following configuration options:

Authentication

This allows the user to specify the type of authentication to be used with the server. The following methods are supported:

Password Only | This requires the username/password to be provided and no public/private key pair or SSL certificate is used.
Public Key/SSL Certificate Only | This requires the use of the public/private key pair or SSL certificate to be used. The private key/SSL certificate location must be specified in the Private Key/SSL Certificate Path.
Password & Public Key/SSL Certificate | This allows the user to specify the public/private key or SSL certificate and/or the username/password.
Key requires Password | If this option is selected the username field under the General tab must be filled in.

If the method used requires a key, the Key requires Password option allows the user to indicate that the private key is password protected. If this is the case, the user will be prompted for the password once per session, or after changing the account settings.

The authentication method must be supported by the server. For SFTP, the keys used should be in OpenSSH format. For FTPS, a certificate encapsulated in the PEM or PFX format should be used.

Enable Compression

If this option is selected, data is compressed when transferred to/from the server. Depending on server configuration this may enhance transfer speed.


Go To Line Number

Go To Line/Column Number

This command presents the Go to Line/Column Number dialog which allows the user to specify what line/column number focus should be reset to for the active compare pane. The user may enter just a line number or they may choose to enter a line, followed by a forward slash, followed by a column number.

Entering just a line number and pressing the OK button will select/highlight the specified line. Entering both the line and column number and pressing the OK button will select/highlight the specified line and it will place a caret at the specified column position, horizontally scrolling if necessary.


Help Menu

The Help menu offers the following commands:

Index | presents index for Help files
User Forums/Support | links to online user discussion forum
Check for Updates | checks to see if an upgrade/hotfix is available for the version currently being used
Registration | presents dialog for entry of product registration information
About UltraCompare | indicates version being run


Highlighting mode

UltraCompare contains three options for character highlighting.

By Word (default mode)

When selected, if UltraCompare encounters a character that is different in a string, the entire word (all word characters) will be marked as different.

By Character

When selected, only the individual different characters will be marked as different.

By Line
When selected, if a difference exists on a line, the entire line will be marked as different.


Horizontal Layout

This option causes the compared files to be displayed with one file above the other.


Ignore Column Ranges

When the Ignore Column Ranges command is selected the Ignore Column Ranges dialog is presented. Users may enter up to four ranges separated by semi-colons. For example, a user could enter '1-5; 7-10'. If the user presses the 'OK' button the menu item is checked and UltraCompare will ignore columns with the range of 1-5 and 7-10 comparing everything else. A difference would only be indicated outside the bounds of these ranges. If a difference is detected all other columns would be represented by the correct difference text color and background color. Selecting the menu item a second time disables this comparison. UltraCompare will remember the last ranges entered.

Please note: The options to Compare/Ignore Column Ranges are exclusive (i.e. only one may be selected at a time).


Ignore Line Terminators

This item may be selected to allow the active compare to ignore line terminator differences (DOS/UNIX/MAC) when comparing files for differences.


Ignore Blank Lines

This item may be selected to allow the active compare to ignore lines that only include line terminators (as appropriate to the active file type) when determining differences between the active files. This does not include lines that contain tabs or spaces (whitespace).


Ignore Case

This item may be selected to allow the active compare to ignore case when comparing files for differences.


Folder

Folder (Configuration - Ignore Options)

The Folder branch under Configuration - Ignore Options has the following options:

Ignore files/folder types

This control may be used to add a semi-colon delimited list of folders, files, and file extensions to be ignored in Folder Compare Mode. For example, a user may enter ‘CVS’ and any time the file or folder CVS is located in a folder it will be ignored when executing and displaying a folder compare. A user may even enter an absolute path to a file/folder to be ignored. An asterisk (*) can be used as a wild card. In order to ignore all files of a particular type the asterisk will be used with the file extension. For example, a user may enter the line ‘*.txt;*.php;*.asm’ and the file extensions .txt, .php, and .asm will be ignored when executing and displaying a folder compare.


Ignore Whitespace

This item may be selected to allow the active compare to ignore tabs and spaces when comparing files for differences.


Index

Index (Help menu)

Selecting this option causes the index for the Help files to be displayed.


Integrate with Explorer

When selected, this command adds UltraCompare options to the context (right-click) menu in Windows Explorer. This is a powerful mechanism for quickly specifying what files/folders to compare and invoke UltraCompare Professional to execute this task

If Integrate with Explorer is selected in the Options menu the items below will be added to the context menu for Explorer:

If desired, users may specify what files/folders/zip archives should be loaded for each frame by right-clicking on an item in Explorer and selecting what frame this should load to in the context menu.

Once the desired items are specified, Run UltraCompare may be selected to run UltraCompare. Being able to save selections on a frame-by-frame basis allows users to select files/folders for comparison from different folders or drives.

When UltraCompare is launched it will automatically switch to Text Compare or Folder Compare mode as appropriate. If three items are selected for comparison the appropriate 3-way mode will be launched.

For faster operation, users may hold down the CTRL key and select multiple items from the same directory for comparison and then right-click and select Run UltraCompare. UltraCompare Professional will automatically load the selected items into frames for comparison and launch in the appropriate mode.


Key Mapping

Key Mapping (Configuration)

The Key Mapping branch in Configuration may be used to reassign the default key mapping provided by UltraCompare Professional to suit the user's needs.

This dialog shows a list of commands within UltraCompare Professional that may be mapped by the user to a key combination of their choice. Clicking on any of the commands will show the existing key assignment (if any) and the command description below the list.

To add or change a command key assignment:

1) Select the command you wish to modify from the Commands list.

2) Clicking the mouse in the Press New Key entry window area, or TAB to give it focus.

3) Type the new key assignment just as you would if you were invoking the command - This key combination will be captured and displayed.

4) Click on the Assign button and the new key will be assigned to the command. If an existing key is assigned you will be asked if you wish to delete it and replace with the new assignment.

To remove a key assignment:

1) Select the command you wish to modify from the Commands list.

2) Select the existing key assignment from the Existing keys list.

3) Click on the Remove button and the key assignment will be removed.

To reset the key assignments to the default:

1) Click on the Defaults button and the key assignments will be reset to the defaults. The users will be prompted to confirm the action.


Line Mode Merge

This command switches the merge function from block merge to selected line merge. By default the block mode merge is active. In this mode you can only use the icons Go to Next Difference and Go to Previous Difference and merge the current block with Merge First to Second, Merge Second to First, etc.

If you want to select individual lines in differenced blocks for merging, you must enable the Line Mode Merge option in the Merge menu or select the Save Merge Changes (disk) icon in the toolbar.

Once this is done, you may select the lines by clicking with the left mouse button at a line and using Shift and Ctrl to select a range of lines (Shift) or select/unselect individual lines (Ctrl).

After you have selected the lines in first OR second file, select with a single left mouse button click the line in the other file (side), where the selected lines should be inserted before or after this line.

With this method you can select (for example) in file 1 (left side) the lines 8-20, 25 and 30 and insert these lines in file 2 (right side) before or after line 50.

You cannot replace a line in the other file with the selected lines. Simply select after inserting the lines you don't need anymore and press the DEL key to delete the selected lines.


Manage Themes

The Manage Themes dialog may be used to modify themes, create new themes, delete themes, and import/export (open and save) themes. The Manage Themes dialog has three major sections: Application, Editor, and Syntax. The top row of controls are present when any of the three tabs are selected.

The Theme dropdown allows users to select themes which have already been specified. The four buttons in the top row of controls support the following features:

The Add theme button presents a submenu with two options: Add new theme and Add existing theme.

The Delete theme button removes the selected theme from the system
The Export theme button opens a file browser dialog where the user may save the theme selected in the Theme dropdown
The Revert theme to defaults button resets the selected theme to its defaults (erasing any user modifications/overrides)

Add new/existing theme

If Add new theme is selected from the Add theme submenu, this presents a New Theme dialog where users may specify the name of the new theme as well as an existing theme whose settings will be used as a basis for the new theme to be defined. By default, the currently active theme will be automatically selected. When the users clicks OK, the new theme will be created and will be made active in the Theme dropdown and the user may begin modifying the associated settings.

If Add existing theme is selected, this will open a file browser dialog where the user may select an existing theme file. The selected theme will then be copied to the user's themes directory and the Theme dropdown will automatically switch to the newly imported theme. The active theme will not actually be changed until Apply or OK is pressed.

Manage Themes - Application

The Application tab of the Manage Themes dialog offers the following functionality:

Application style dropdown | allows users to select from a pre-defined list of default styles for the application as a whole
Set styles for dropdown | allows users to configure the color of specific elements within the application such as dockable windows, menus, toolbars, file tabs, and more
Dockable window font | if applicable for the selected item, the Set font button will be active and may be used to set the font/size/style of text in the selected item
Foreground swatch | presents an OS color picker dialog which may be used to define the color of the selected item
Background swatch | presents an OS color picker dialog which may be used to define the color of the selected item

The preview button [image] allows the user to preview changes in the main application window in real time. When this is toggled on, a user may preview modifications to a theme as he makes them and then toggle this off to see the changes compared to current settings.

Manage Themes - Compare

The Compare tab of the Manage Themes dialog offers the following functionality:

Text compare font | allows users to set font for text compares
Binary compare font | allows users to set font for binary compares
Set style for dropdown | allows users to configure the color of specific modes within the application such as Text Compare, Binary Compare, and Folder Compare
Foreground swatch | presents an OS color picker dialog which may be used to define the color of the selected item
Background swatch | presents an OS color picker dialog which may be used to define the color of the selected item

Manage Themes - Syntax

The Syntax tab of the Manage Themes dialog offers the following functionality:

Language dropdown | allows user to select the syntax highlighting language for which styles will be set. The language list is populated with the names of languages from the user's wordfiles folder. Along with the defined languages, there is a Default language setting (described below)
Defaults button | allows users to revert to a language's color/style settings for all color groups back to the defaults
Set styles for dropdown | allows users to select a specific language item within the selected language and define colors/styles (e.g. normal text, comments, color groups, etc.)
Foreground swatch | presents an OS color picker dialog which may be used to define the color of the selected item
Background swatch | presents an OS color picker dialog which may be used to define the color of the selected item
Font styles | allow users to pick a font style (normal, bold, italic or underline) for the selected language item
Enable background color | if checked, this causes the background color for "Normal text" from the theme's editor color settings to be used for the selected item, overriding the background color setting here


Management

Management (Configuration - Toolbars/Menus)

The Management branch under Configuration - Toolbars/Menus has the following options:

Manage Toolbars

Pressing this button presents the Toolbar Configurations dialog. Pressing the Reset button restores default toolbar configurations.

Manage Menus

Pressing this button presents the Menu Configurations dialog. Pressing the Reset button restores default menu configurations.


Matches only

This option causes only lines that are identical in the compared files to be displayed.


Merge Menu

The Merge menu offers the following commands:

Line Mode Merge | switches merge function from block merge to selected line merge
Merge First to Second | merges selection from first to second file
Merge Second to First | merges selection from second to first file
Advanced Merge | merges selection from left to right (or right to left) either above or below the differenced line without overwriting the existing text
Accept All | accepts all merge changes in specified files
Merge Undo | reverses the last merge action
Undo All Changes | reverses all unsaved changes to compared files/folders
Prompt on Replace Newer File | prompts user if merge action will overwrite a file newer than the file being merged
Prompt on Merge | prompts user before each merge is completed
Refresh After Merge | refreshes compare status after each merge is completed


Merge Toolbar

The Merge toolbar includes the following functions:

Basic (size and date only) | sets active folder compare mode to Basic (size and date only)
Full (byte-by-byte) | sets active folder compare mode to Full (byte-by-byte)
Smart (includes text compare with ignore options) | sets active folder compare mode to Smart (includes text compare with ignore options)
Recursive Compare | compares all subdirectories of folders specified for compare rather than just the top level directory
Parent Directory | resets all panes of directory compare to parent directory
Reset Column Widths | optimizes columns widths for Folder Mode display
Folder Compare Symbols | displays dialog with folder compare legend defining folder compare symbols
Merge First to Second | merges selection from left file to right file overwriting active block
Merge First to Second (After the block) | merges selection from left file to right file after selected block
Merge First to Second (Before the block) | merges selection from left file to right file before selected block
Merge Second to First | merges selection from right file to left file overwriting active block
Merge Second to First (After the block) | merges selection from right file to left file after active block
Merge Second to First (Before the block) | merges selection from right file to left file before active block
Line Mode Merge | toggles Line Mode / Block Mode Merge
Save Merge Changes | saves all merged changes
Undo All Changes | restores both files to last saved state
Undo Last Merge | reverses last merge operation
Go | starts comparison of specified files/folders
Refresh | repeats compare to refresh differences indicated
Stop Compare | stops active compare
Maximize First Pane | toggles display of first pane between maximum and default sizes
Maximize Second Pane | toggles display of first pane between maximum and default sizes
Maximize Third Pane | toggles display of first pane between maximum and default sizes
Show Line Numbers | displays line numbers in the compared files
Relational Lines Mode | changes presentation of text compare to display linking and border lines for differenced blocks between matching blocks of text
Show Active Line Window | displays active line window to highlight differences between the lines which have focus in the active compare
Show Output Window | displays the output window where the results of the commands executed for the active session are displayed
Show Workspace Manager | displays the Workspace Manager including the Explorer and Sessions panes


Merge First to Second

After a line is marked for merge this command may be used to merge the selected line from the file displayed on the left to the file displayed on the right. In 3-Way Text Mode, if the splitter bar between the second and third files is selected, this would become Merge Second to Third.

Merged lines will be indicated with a different background color to facilitate quickly checking all merge changes prior to saving.

Keyboard Shortcut: Alt+Right Arrow


Merge Second to First

After a line is marked for merge this command may be used to merge the selected line from the file displayed on the right to the file displayed on the left. In 3-Way Text Mode, if the splitter bar between the second and third files is selected, this would become Merge Third to Second.

Merged lines will be indicated with a different background color to facilitate quickly checking all merge changes prior to saving.


Merge Undo

This command may be used to reverse the last merge executed.


Text

Text (Configuration - Display - Text)

The Miscellaneous branch under Configuration - Display -Text has the following options:

Mark empty lines

If this option is selected empty lines will be indicated in the compare panes with alternating blue and white vertical lines. If this is not selected, the background color for the compare panes will not change when empty lines are encountered.

Highlight active frames only

If this option is selected only the two active frames in a 3-way compare would show highlighting for character differences. If this is not selected then all three frames would be highlighted to indicate character differences.

Mark merge blocks

If this option is selected merged blocks will be highlighted to support review of merged items prior to saving.

Show tabs

This option displays spaces, tabs, and new line characters as visible characters.

Tab Stop Value

This setting may be used to set the number of spaces a TAB character should be equal to for display purposes.

Show active line window

This option displays an additional window highlighting the differences between the lines which have focus in the active compare.

Differences indicator

This setting determines if difference indicators should be displayed between line numbers and text during a Text Compare.

Compare Symbol | Meaning
!> | data exists in right frame but not left
<! | data exists in left frame but not right
!! | only empty lines exist here
* | data exists in both frames but is different

Merge buttons on splitter

This option is a toggle to display or not display Merge Buttons on the bar separating adjacent compare frames.

Show line numbers

Selecting this option causes line numbers for the compared files to be displayed to the left of the contents of each file. This can be particularly helpful in identifying where the same lines may occur in both files but in different locations and also helps to clarify where lines occur in only one of the compared files (in this case line numbers would not be displayed in the file in which the compared lines do not occur).


Miscellaneous

Miscellaneous (Configuration - Display - Folder)

The Miscellaneous branch under Configuration - Display - Folder has the following options:

Show preview file

If this option is selected, an additional pane is displayed to the right during a folder compare and when files are selected in the Folder Mode output that only occur on one of the compared drives or where files are identical, their content will be displayed in the additional pane for faster review of compared differences between folders.

Enable Stripes

If this option is selected alternating background colors will be used for lines in Folder compares.

Show file/folder icons

If this option is selected, the same icons used by Windows Explorer will be displayed before the file/folder name during folder mode compares.

Display root directories

If this option is selected, the full directory tree will be displayed from the root when a folder compare is executed. If this is not selected, the folder compare will only display the directory tree beginning with the folders being compared.


Miscellaneous

Miscellaneous (Configuration - Find Duplicates)

The Miscellaneous branch under Configuration - Find Duplicates has the following options:

Show warning prompt when deleting files

If this option is selected and the user selects files to be deleted from those reported as duplicates in the Results Report, a confirmation dialog will be displayed to ensure that this is the desired action.


Mode

The Mode menu offers the following commands (only the options related to the current mode will be displayed):

Text Mode | switches active compare to Text Mode compare
3-Way Text Mode | switches active compare to 3-Way Text Mode compare
Binary (fast) Mode | switches active compare to Binary (fast) Mode compare
Binary (smart) Mode | switches active compare to Binary (smart) Mode compare
Folder Mode | switches to Folder mode (active file compare will be lost)
3-Way Folder Mode | switches active compare to 3-Way Folder Mode compare
Folder Synchronization Mode | switches active compare to Folder Synchronization Mode
Table Mode | switches active compare to Table Mode compare


New Compare

This command presents a submenu where users may select the mode to be used for the new session to be created. The following keyboard shortcuts may also be used to create a new session:

New Session Mode

Text Mode

3-Way Text Mode

Binary (fast) Mode

Binary (smart) Mode

Folder Mode

3-Way Folder Mode

Table Mode


New Session

This command presents a submenu where users may select the mode to be used for the new session to be created. The following keyboard shortcuts may also be used to create a new session:

New Session Mode

Text Mode

3-Way Text Mode

Binary (fast) Mode

Binary (smart) Mode

Folder Mode

3-Way Folder Mode

Table Mode


Open First/Second/Third

These commands invoke the File Open dialog which may be used to specify the file to be opened for compare in Text Compare mode. The same mechanism may also be used in Folder Compare mode to specify directories to be opened for compare.


Open from FTP

Use this command to open a file via FTP. This command presents a custom dialog that allows selection of the site/account to browse.

The Accounts [1] button may be pressed to open the FTP Account Manager where new accounts may be specified. A new account must be configured for each site to be connected to as each site may have unique settings.

A list of configured accounts is shown in the center dropdown [2] and any of the configured accounts may be selected. Once the desired account is selected, the Connect [3] button must be pressed to initiate the connection to the server. When a connection is established, this will be replaced with a Disconnect [3] button which may be used to terminate the connection.

Pressing the Return to Initial Directory [4] button will navigate to the directory initially loaded for the active session.

Pressing the Parent Directory [5] button will navigate to the parent folder of the active directory. Pressing the Refresh [6] button refreshes (rereads) the directory information from the host server.

Double-clicking on any of the directories shown in the list will attempt to change to the specific directory. Additionally the Change Directory [7] combobox may be used to type in a directory to change to. This will automatically store a list of all paths typed into it.

The directory list displayed may be filtered to show a subset of files by specifying a filter in the Filter [8] text field. The Filter text field supports Perl regular expressions as well as standard wildcards. This filter only affects the listing downloaded from the server and displayed in the integrated FTP client. This will automatically store a list of all filters typed into it. This list may also be sorted by clicking on any of the column headings [9] for the list (Name, Size, Date, Type).

New directories may be created on the host server by right-clicking in the list and selecting Make Directory from the context menu [10]. Additionally the Hide Directories [11] checkbox will cause directories not to be shown.

To open a file, select it and click on the Open First, Open Second, or Open Third [14] button as appropriate for the active compare. If the full path to the file to be opened is known, this may be typed in the Open [13] text field and navigation to the file is not required. The transfer progress will be shown as the file is transferred.

While an operation is in progress a warning will be shown if an attempt to start another operation is made, or canceling the dialog is requested. While files are being transferred, or a site is being connected to, the dialog will show the current status [15]. The transfer will be executed using the specified transfer type [12] (ASCII or Binary). Binary transfers the file byte-for-byte with no modification. ASCII causes the file to be appropriately converted for line terminations between different systems. Depending on the FTP server/client, an ASCII transfer may corrupt the file as this is a 7-bit transfer. For this reason, Binary is the preferred transfer type.

By default after the file is retrieved and open the dialog will be closed if the option Close Dialog after Transfer [16] is set. This option may be cleared to have the dialog remain open.

If there are problems connecting to the server, it may be useful to select Show FTP log in output window under the FTP section in the Configuration dialog. This will display a log of the session showing all commands sent to and data received from the FTP server in the output window. This can provide helpful diagnostic information and the contents of this window may be copied using the clipboard.

The context menu in this dialog includes the following options:

Make Directory | creates a new directory on the host server. No checking of the name or syntax is performed. Any errors are reported back from the host server.
Delete | deletes a remote file or directory on the host server
Rename | renames a remote file or directory on the host server
Permissions | allows the file permissions to be set on a remote file. This will only work on servers that recognize the FTP "Site" command chmod. Typically this would only be UNIX/Linux servers.


Options Menu

The Options menu offers the following commands for text mode compares:

Configuration | presents Configuration dialog with index tree to access categorized configuration options
Color | presents color and font settings dialog appropriate to the active mode
Set Filter | presents Set Filter dialog allowing the user to specify what file types should be displayed in a Folder Compare
Compare Column Ranges | presents a dialog where the user may enter up to four ranges of columns to be compared
Ignore Column Ranges | presents a dialog where the user may enter up to four ranges of columns to be ignored
Specify Extensions | presents a dialog for user to specify extensions for file types to be interpreted as text or binary files by default (only available in Pro version)
File Ignore Options - Ignore Blank Lines | forces the compare to ignore lines containing only line terminators when comparing the active files
File Ignore Options - Ignore Whitespace | forces the compare to ignore tabs and spaces when identifying differences in the active files
File Ignore Options - Ignore Case | forces the compare to ignore case when identifying differences in the active files
File Ignore Options - Ignore Line Terminators | forces the compare to ignore line terminator differences (DOS/UNIX/MAC) in the active files
Decimal Offset | switches offset displayed in binary mode from HEX to decimal
Integrate with Explorer | adds UltraCompare options to context menu in Windows Explorer

The Options menu offers the following commands for folder mode compares:

Configuration | presents Configuration dialog with index tree to access categorized configuration options
Color | presents color and font settings dialog appropriate to the active mode
Set Filter | presents Set Filter dialog allowing the user to specify what file types should be displayed in a Folder Compare
Specify Extensions | presents a dialog for user to specify extensions for file types to be interpreted as text or binary files by default (only available in Pro version)
Folder Mode Filters | presents submenu with filter options for folder mode compares
File Ignore Options - Ignore Blank Lines | forces the compare to ignore lines containing only line terminators when comparing the active files
File Ignore Options - Ignore Whitespace | forces the compare to ignore tabs and spaces when identifying differences in the active files
File Ignore Options - Ignore Case | forces the compare to ignore case when identifying differences in the active files
File Ignore Options - Ignore Line Terminators | forces the compare to ignore line terminator differences (DOS/UNIX/MAC) in the active files
Folder Ignore Options - Ignore Timestamp Differences | forces the compare to ignore timestamp differences when comparing the active folders
Decimal Offset | switches offset displayed in binary mode from HEX to decimal
Integrate with Explorer | adds UltraCompare options to context menu in Windows Explorer


Output Window

This command displays the Output Window containing different data depending on the type of compare in progress. During a Text Compare this would summarize the number of blocks and lines that are different between the two files being compared. During a Folder Compare the resulting dialog would summarize file and subdirectory differences in compared folders.

Right clicking in the Output Window displays a context menu with the following options:

Hide Output Window | hides Output Window
Clear Output: Active Session | clears the contents of the Output Window for the active session only
Clear Output: All Sessions | clears the contents of the Output Window for all sessions
Copy to Clipboard | copies the contents of the Output Window for the active session to the clipboard
Scroll Output | controls whether output window focus scrolls to last line when populated or remains at the current line


Path Toolbar Commands

The following commands are available in the File/Folder Path toolbar:

Path Combo Box | used for entry/selection of path to file/folder for compare
Folder Parent | shifts active pane up to parent folder in folder compare
Open File/Folder | opens specified file/folder in active pane
Close File/Folder | closes active file/folder
Encoding | presents context menu allowing encoding selection for active file in text compare (see below)

When the Encoding button is pressed in the Path toolbar the user may specify the encoding to be used for comparing the active file in text compare mode.


Preview First/Second/Third

This command displays the selected file as it would appear when printed. When you choose this command the main window will be replaced with a print preview window in which the selected file will be displayed in its printed format.

The print preview toolbar offers options to initiate a print job, move back and forth through the result summary, display one or two pages at a time, zoom in and out, and close the print preview window.


Print

Use this command to print a result summary . This command presents a Print dialog box where you may specify the range of pages to be printed, the number of copies, the destination printer, and other printer setup options.

Keyboard Shortcut: Ctrl+P


Print Preview

This command displays the result summary as it would appear when printed. When you choose this command the main window will be replaced with a print preview window in which the result summary will be displayed in its printed format.

The print preview toolbar offers options to initiate a print job, move back and forth through the result summary, display one or two pages at a time, zoom in and out, and close the print preview window.


Print Result

Use this command to print a result summary . This command presents a Print dialog box where you may specify the range of pages to be printed, the number of copies, the destination printer, and other printer setup options.


Print Settings

Page Setup

The Page Setup dialog under is accessed from Print Setup/Configuration in the Application menu and includes settings that may be used to set up page headers and footers for printing. The page header, if configured, is printed at the top of every page. The page footer, if configured, is printed at the bottom of every page. If a page footer or header is configured, a single line is printed across the page between the header or footer and the text to be printed.

The header or footer may be disabled by selecting the appropriate check box. If the header or footer is enabled, the separator line that is normally printed between the header/footer and the page text may optionally be disabled.

The page header and footer may include text defined by the user, and additionally special characters to allow the file name and page numbers to be printed in the header or footer.

The special characters are:

&f | This is replaced in the header or footer with the full file name including path.
&n | This is replaced in the header or footer with the file name only (no path).
&p | This is replaced in the header or footer with the page number.
&t | This is replaced in the header or footer with the total number of pages.
&l | This aligns the text following the "&l" to the left side of the header/footer area.
&c | This aligns the text following the "&c" to the center of the header/footer area.
&r | This aligns the text following the "&r" to the right side of the header/footer area.

(Note - the alignment characters are not required, and any or all of them may appear in a single header or footer. However, if more than one is present, they must be in the order above -- "&l" must be before "&c" and "&c" must be before "&r").

Additionally, the header or footer may include the file date and time or system date and time. Two radio buttons allow the selection of either the file date, or the system date to be included in the header or footer. The radio buttons select the source of the date and time, additional special characters used in the header or footer specify if the date and time are to be printed and what format is used.

The characters used to specify the time and date format are shown below, the absence of any of these characters result in the time and date not being printed.

The formatting codes date and time are listed below:

Format | Description
%a | Abbreviated weekday name
%A | Full weekday name
%b | Abbreviated month name
%B | Full month name
%c | Date and time representation appropriate for the locale
%d | Day of the month as a decimal number (01-31)
%H | Hour in 24-hour format (00-23)
%I | Hour in 12-hour format (01-12)
%j | Day of the year as a decimal number (001-366)
%m | Month as a decimal number (01-12)
%M | Minute as a decimal number (00-59)
%p | Current locale's AM/PM indicator for a 12-hour clock
%S | Second as a decimal number (00-59)
%U | Week of the year as a decimal number, with Sunday as the first day of the week (00-51)
%w | Weekday as a decimal number (0-6; Sunday is 0)
%W | Week of the year as a decimal number, with Monday as the first day of the week (00-51)
%x | Date representation for current locale
%X | Time representation for current locale
%y | Year without the century as a decimal number (00-99)
%Y | Year with the century as a decimal number
%Z | Time zone name or abbreviation; no characters if time zone is unknown
%% | Percent sign

Examples:

Date is July, 4th 1994. Time is 9:00pm

"%X , %x" prints "21:00 , 07/04/94"

Date is July, 4th 1994. Time is 9:00pm

"%c" prints 07/04/94 21:00

Date is Jan, 10th 1991. Time is 5:00am

"%A, %B %d, %Y %I:%M%p" prints Tuesday, January 10, 1991 05:00:am

Enable color printing

This option instructs UltraCompare to print the file with the color used for syntax highlighting if a color printer is used. This will also show shades of gray on a Postscript monochrome printer.


Print First/Second/Third

Print First/Second/Third (File menu)

Use this command to print the selected file. This command presents a Print dialog box where you may specify the range of pages to be printed, the number of copies, the destination printer, and other printer setup options.


Prompt on Merge

This option may be set to cause UltraCompare to prompt the user with each merge to ensure that this is indeed what the user intends to do.


Prompt on Replace Newer File

In Folder Compare mode if a user attempts to merge differenced files from one directory to another and UltraCompare detects that the users action will overwrite a file newer than the one being merged into the receiving directory, a prompt dialog will appear to confirm that this is indeed what the user intends to do.


Refresh

This command repeats the active compare to ensure that all the most up-to-date differences are displayed. This can be useful after the Edit in UltraEdit option has been used to modify one of the active files during a Text Compare or if files/folders have been modified during a Folder Compare .


Refresh After Merge

This option only applies in Folder Mode. If selected, this will force a refresh of compared directories (and the status of the compare) whenever a file/folder is merged from one compared folder to the other. If this option is not selected, the automatic refresh/recompare will not occur.

This was originally enabled so that if files/folders should be changed outside of UltraCompare Professional during a compare this would be reflected in the compare status. If it is known that this will not be the case, then it may be preferred not to have this item selected.


Registration

This option presents the Registration dialog where the user name and registration code is entered to register the product. These are obtained by ordering a paid license from IDM Computer Solutions, Inc. or an authorized distributor/ reseller.


Relational Lines Mode

This option toggles the state of a Text Mode compare or 3-Way Text Mode compare to be displayed using relational lines rather than by performing a line-by-line comparison. A normal text comparison searches line-by-line for differences between compared files. If Relational Lines Mode is selected, UltraCompare attempts to find matches between the content of the compared files and exclude this from the difference comparison while indicating related blocks and the differences between them visually:

There are two primary differences to be noted in Relational Lines Mode:

The graphical navigation map [1] changes to show navigation maps for both compared files side-by-side rather than a composite difference map for the two files. This allows a separate location block (red rectangle) for each file as well as pointing out graphically where differences occur between the two files.

Differenced blocks that UltraCompare identifies as existing between matching sections of text in the compared files are bordered by lines of the same color as the lines connecting related blocks.

Where differenced blocks are offset (not parallel in the display) double-clicking on the connecting line will cause the related blocks in each file to be centered in the display panes.


Save & Backup Options

Backup & Save (Configuration)

The Backup & Save branch under Configuration includes the following options:

Save result in Unicode

This option forces the output file for file/folder compares to be saved in Unicode format.

Create backup copy

This option may be used to create a backup of the compared files. This is suggested prior to repeated merge commands so that a "baseline" file is maintained to restore if necessary.

Create backup copy of zip archives

This option forces UltraCompare to create backups prior to comparing zip archives.

Side by side result

If this option is selected the result file will show differences side by side rather than one above the other.

Differences in context result

If this option is selected the result file will show differences in context (i.e. with a few of the lines that occur before and after them to give a clearer picture in the result file of where the differences occur).

Display result for one frame only

If this option is selected the result file will only show differences for the active pane of currently compared files. This limited result will obey the selected compare options (All, Just Differences, Just Matching).

Display result for all frames

If this option is selected the result file will show differences for all panes of currently compared files. This result will obey the selected compare options (All, Just Differences, Just Matching).


Save As to FTP

Use this command to save an open document/file via FTP. This command presents a custom dialog that allows selection of the site/account to browse.

A list of configured accounts is shown and any of the accounts may be selected. If a new account is selected from the list UltraCompare automatically tries to connect to the site and browse it.

A new account must be configured for each site to be connected to as each site may have a different name, password, directory, etc.

When the dialog is displayed the browse button will display the list of files for the given site. Double-clicking on any of the directories shown in the list will attempt to change to the specific directory.

The directory list may be filtered to show a sub-set of files by specify a filter in the Filter text field.

To save the file, type in the filename or click on an existing filename and click the Save As button. The transfer progress will be shown as the file is transferred.

While an operation is in progress a warning will be shown if an attempt to start another operation is made, or canceling the dialog is requested.

While files are being transferred, or a site is being connected to the dialog will show the current status.

From this dialog additional FTP functionality is available:

Refresh | refreshes (rereads) the directory information from the host server
Create Dir | creates a new directory on the host server. No checking of the name or syntax is performed. Any errors are reported back from the host server.
Permissions | allows the file permissions to be set on a remote file. This will only work on servers that recognize the FTP “Site” command chmod. Typically this would only be UNIX/Linux servers.
Rename | renames a remote file or directory on the host server
Delete | deletes a remote file or directory on the host server
Transfer Type | allows the transfer type of ASCII or Binary to be set for the account. Binary transfers the file byte-for-byte with no modification. ASCII causes the file to be appropriately converted for line terminations between different systems.
Show Log | If checked, a log of the session showing all commands sent to and data received from the FTP server is shown in a window in place of the directory listing. The user may reposition within the window and the contents of this window may be copied using the clipboard.

In Folder Mode, selecting Save As to FTP will present the FTP Upload Files/Folders dialog where users may specify which items should be uploaded to the FTP server. Files and folders which were opened via FTP and included in the active compare will be listed in a tree structure in the appropriate pane:

Items which have been merged/modified will be indicated in red and selected for transfer automatically. If a folder has a black box with a green checkmark, this indicates that all items in the folder have been modified and selected for transfer. If a folder has a green box with a green checkmark, this indicates that at least one item in the folder has been modified and selected for transfer. Pressing the Upload button will initiate the transfer. Selected items will be uploaded using the transfer type selected for the account.


Save Result

This command saves the result summary of the active file compare in text format. This may be invoked from the Application Menu and opens a Save As dialog so the user may specify where to save the result summary and what it should be named. This command is active both during a Text Compare and a Folder Compare .


Save Merged Changes

This command saves all merge changes made in the current compare session regardless of which file the changes were made in. This command is only available after a Merge operation.


Scheduler

Scheduler (Configuration - Compare - Folder Sync)

The Scheduler dialog allows users to specify when Folder Sync sessions should be automatically executed. This may be accessed either through Configuration or by clicking on the Folder Sync Scheduler button in the Main toolbar.

It is important to note that only sessions which have previously been saved may be scheduled for automatic execution.

If a Folder Sync session has been saved, users may use the Add Task button to schedule it for future execution. If the session has already been scheduled, the Modify Task button may be used to change the options associated with this task. The Delete Task button may be used to remove a scheduled task.

The following options may be configured for the scheduler:

Launch scheduler at startup

If this option is selected, UltraCompare will be started and minimized to the system tray when the host system is started.

the scheduler dialog will be automatically displayed each time UltraCompare is started.

Show prompt before shutdown/restart

If this option is selected, a warning prompt will be displayed if the user attempts to shutdown/restart UltraCompare when a Folder Sync session is scheduled. If UltraCompare is closed, a scheduled session will not be executed. Users may choose to minimize UltraCompare to the system tray if preferred.

Enable logging

If this option is selected, a log file will be created each time a scheduled session is executed.

Add/Modify Task

When either the Add Task or Modify Task button is pressed, the Modify scheduler task dialog is displayed. User may select a saved session here and modify the settings associated with that session.


Session Menu

The Session menu offers the following commands:

New Session | presents submenu where user may select mode for creating next session - does not allow toggling between modes
Define Session | presents submenu where user may select mode for defining next session - allows toggling between modes
Save Active Session | saves active session
Group And Save All Sessions | creates a new session group in Sessions pane of Workspace Manager and adds all active sessions to newly created group
Session Properties | presents Session Properties dialog for active session
Close Active Session | closes active session
Close All Sessions | closes all active sessions
Close All Sessions Except This | closes all sessions except the one current active
Rename | highlights text of active session tab so user may rename it

These commands are also available from the context menu of each session tab.


Session Properties

Session Properties dialog

The Session Properties dialog allows users to specify settings for an active or new session. There are separate tabs for Text Mode, Binary Mode, and Folder Mode sessions settings.

Common Settings

The following options are available under all tabs in the Session Properties dialog:

Session Name

If desired, the name of the session may be changed by the user here.

Group Name

If the active session belongs to an existing Group, that Group name will be displayed in this field.

OK and Run

If this button is pressed, the options selected for the session will be saved and the Session Properties dialog will be dismissed. The modified session will immediately be launched and executed. If the modified session is already open, it will be refreshed using the modified settings.

OK

Pressing OK will cause the modified session settings to be saved and will dismiss the Session Properties dialog, but this will not launch or execute the related session.

Apply

Pressing Apply will cause the modified session settings to be saved but will not dismiss the Session Properties dialog nor launch or execute the related session.

Text Mode Settings

Files

Users may specify the full paths to files to be compared in a session using these text fields. If preferred the [image] button may be pressed to present a dialog where users may browse to files on the local system. If the [image] button is pressed, the FTP Open dialog will be displayed allowing users to specify files to be opened via FTP from a remote server for comparison.

Compare options

The following compare options may be configured for each text mode session:

Relational lines mode

Word wrap

Line mode merge

Use character to character line comparison

Ignore options

The following ignore options may be configured for each text mode session:

Ignore blank lines

Ignore whitespace

Ignore case

Ignore line terminators

Ignore lines which... begin with / contain / end with

Ignore a defined number of lines at beginning / end of file

Compare / Ignore column ranges

Compare

Ignore

Display options

The following display options may be configured for each text mode session:

Mark empty lines

Show scaled map

Show tabs

Tab stop value

Binary Mode

Files

Users may specify the full paths to files to be compared in a session using these text fields. If preferred the [image] button may be pressed to present a dialog where users may browse to files on the local system. If the [image] button is pressed, the FTP Open dialog will be displayed allowing users to specify files to be opened via FTP from a remote server for comparison.

Compare options

The following compare options may be configured for each binary mode session:

Fast binary compare

Smart binary compare

Display offset as decimal

Folder Mode

Folders

Users may specify the full paths to folders to be compared in a session using these text fields. If preferred the [image] button may be pressed to present a dialog where users may browse to files on the local system. If the [image] button is pressed, the FTP Open dialog will be displayed allowing users to specify folders to be opened via FTP from a remote server for comparison.

Compare options

The following compare options may be configured for each folder mode session:

Basic (size and date only)

Full (byte-by-byte)

Smart (includes text compare with ignore options)

Text mode in result

Recursive compare

Use CRC compare

Ignore options

The following ignore options may be configured for each folder mode session:

Ignore folders/file types

Ignore timestamp differences

File Ignore Options

When this button is pressed, a dialog is displayed which may be used to modify file ignore options for the active session.

Filter options

The following filter options may be configured for each folder mode session:

Hide same files

Hide different files

Hide common files

Hide unique files

Hide same folders

Hide different folders

Hide common folders

Hide unique folders

Display options

The following display options may be configured for each folder mode session:

Display root directories

Show preview file


Session Template

This command presents a submenu where users may select the mode to be used for the new session to be created.

Text Mode

3-Way Text Mode

Binary (fast) Mode

Binary (smart) Mode

Folder Mode

3-Way Folder Mode

Table Mode

After the mode is selected, the user is then shown the appropriate Session Properties dialog. This session is immediately saved for later use.


Sessions

The Sessions branch under Configuration has the following options:

Reload sessions previously open on startup

If this option is selected, sessions which were active the last time UltraCompare was used will automatically be reloaded when the application is launched. These sessions will also be listed in the Sessions pane of the Workspace Manager under the Recent Sessions Group heading.


Set Compare Options

The command will launch the Current Session Properties dialog, which allows users to specify settings for an active or new session. There are separate tabs for Text Mode, Binary Mode, and Folder Mode sessions settings.

Common Settings

The following options are available under all tabs in the Session Properties dialog:

Session Name

If desired, the name of the session may be changed by the user here.

Group Name

If the active session belongs to an existing Group, that Group name will be displayed in this field.

OK and Run

If this button is pressed, the options selected for the session will be saved and the Session Properties dialog will be dismissed. The modified session will immediately be launched and executed. If the modified session is already open, it will be refreshed using the modified settings.

OK

Pressing OK will cause the modified session settings to be saved and will dismiss the Session Properties dialog, but this will not launch or execute the related session.

Apply

Pressing Apply will cause the modified session settings to be saved but will not dismiss the Session Properties dialog nor launch or execute the related session.

Text Mode Settings

Files

Users may specify the full paths to files to be compared in a session using these text fields. If preferred the [image] button may be pressed to present a dialog where users may browse to files on the local system. If the [image] button is pressed, the FTP Open dialog will be displayed allowing users to specify files to be opened via FTP from a remote server for comparison.

Compare options

The following compare options may be configured for each text mode session:

Relational lines mode

Word wrap

Line mode merge

Highlighting Mode

Ignore options

The following ignore options may be configured for each text mode session:

Ignore blank lines

Ignore whitespace

Ignore case

Ignore line terminators

Ignore lines which... begin with / contain / end with

Ignore a defined number of lines at beginning / end of file

Compare / Ignore column ranges

Compare

Ignore

Display options

The following display options may be configured for each text mode session:

Mark empty lines

Show scaled map

Show tabs

Tab stop value

Binary Mode

Files

Users may specify the full paths to files to be compared in a session using these text fields. If preferred the [image] button may be pressed to present a dialog where users may browse to files on the local system. If the [image] button is pressed, the FTP Open dialog will be displayed allowing users to specify files to be opened via FTP from a remote server for comparison.

Compare options

The following compare options may be configured for each binary mode session:

Fast binary compare

Smart binary compare

Display offset as decimal

Folder Mode

Folders

Users may specify the full paths to folders to be compared in a session using these text fields. If preferred the [image] button may be pressed to present a dialog where users may browse to files on the local system. If the [image] button is pressed, the FTP Open dialog will be displayed allowing users to specify folders to be opened via FTP from a remote server for comparison.

Compare options

The following compare options may be configured for each folder mode session:

Basic (size and date only)

Full (byte-by-byte)

Smart (includes text compare with ignore options)

Text mode in result

Recursive compare

Use CRC compare

Ignore options

The following ignore options may be configured for each folder mode session:

Ignore folders/file types

Ignore timestamp differences

File Ignore Options

When this button is pressed, a dialog is displayed which may be used to modify file ignore options for the active session.

Filter options

The following filter options may be configured for each folder mode session:

Hide same files

Hide different files

Hide common files

Hide unique files

Hide same folders

Hide different folders

Hide common folders

Hide unique folders

Display options

The following display options may be configured for each folder mode session:

Display root directories

Show preview file


Set Time/Date Format

Date & Time Format (Configuration)

The Date & Time Format branch under Configuration has the following options:

Format string

This field may be used to specify the format of the string used to display date and time during a file compare. Users may type the desired format string directly in the format string field or use the Format Elements button to select and insert string elements as desired.

Alignment

Users may select Left, Center, or Right to control the position of the date/time string in the associated folder compare columns.

Restore System Format

If this button is pressed, the default system format for date/time strings will be restored.

Format Elements

Pressing this button presents a popup menu where the user may select elements to be included in the Format string field. Items selected from the Format Elements popup menu will automatically be inserted into the Format string field. If preferred, users may refer to the tables below and type the desired format directly into the Format string field.

Time Elements

The special characters that may be used for time elements are as follows:

h | Hour (1-12)
hh | Hour (01-12)
H | Hour (0-23)
HH | Hour (00-23)
m | Minute (0-59)
mm | Minute (00-59)
s | Second (0-59)
ss | Second (00-59)
t | A/P
tt | AM/PM

Date Elements

The special characters that may be used for date elements are as follows:

d | Day
dd | Day (2 digits)
ddd | Day Name (abbr.)
dddd | Day Name (full)
M | Month
MM | Month (2 digits)
MMM | Month Name (abbr.)
MMMM | Month Name (full)
yy | Year (2 digits)
yyyy | Year (4 digits)
D | Day of Year
DDD | Day of Year (3 digits)
w | Week Number
ww | Week Number (2 digits)

Separator Elements

The special characters that may be used for separator elements are as follows:

~ | Separator (space)
/ | Date Separator
: | Time Separator

Users may enter other characters to use as separator elements as desired.

Result string

This field displays a sample string showing how the date/time string will be displayed with the specified elements.


Set Filter

Set Filter (Options menu)

This option (only available with Folder Compare mode) will present the Set Filter dialog allowing the user to specify a filter based on file extensions to determine what file types should be shown during the Folder Compare. A single file extension may be defined, i.e.:

*. txt

or a user may define multiple file extensions delimited by commas, i.e.:

*. txt,*. js,*.html

so that the matching file types may be displayed.


Settings Summary

When Settings is selected a Configuration dialog is presented with configuration options divided by category. These may be easily navigated using the index tree to the left of the dialog.

To read about what each setting does, please click on the Contents page in the Help and double click on Menu Commands and then double click on the Options menu and double click on Configuration. This will open a mirror of the index tree in the configuration dialog in the Help files. Users may expand the major sections in the Help:

Compare

Ignore Options

Sessions

Display

Application Layout

File Handling

Backup & Save

Toolbars/Menus

Key Mapping

Shell Integration

UE/UES Integration

Double-clicking on a heading and clicking on the topics included below will provide summaries of the associated options.


Shell Integration Options

Shell Integration (Configuration)

The Shell Integration branch in Configuration includes the following options:

Integrate with Explorer

If this option is selected UltraCompare options are added to the context (right-click) menu in Windows Explorer

Enable auto select

If this option is selected the UltraCompare context menu items will automatically be populated with the item currently selected in Windows Explorer.


Show Line Numbers

Selecting this option causes line numbers for the compared files to be displayed to the left of the contents of each file. This can be particularly helpful in identifying where the same lines may occur in both files but in different locations and also helps to clarify where lines occur in only one of the compared files (in this case line numbers would not be displayed in the file in which the compared lines do not occur).

Keyboard Shortcut: Ctrl+L


Sync bottom

This option synchronizes the compare panes with the active line window. Using the scrollbar for the active line window will also scroll both panes.


Sync horizontal

Synch horizontal

This option synchronizes the compare panes so that both files may be scrolled horizontally at the same time by scrolling in either pane.


Sync vertical

This option synchronizes the compare panes so that both files may be scrolled vertically at the same time by scrolling in either pane.


Synchronize

This command is used to re-establish synchronization if it is lost through a merge or other function.


Synchronize Folders

UltraCompare Professional supports synchronization of directories if desired. Users accomplish this by selecting the Sync Folder checkbox at the bottom left of the Folder Compare session.

In a Synchronize Folders session the user chooses two folders they wish to synchronize and then selects a “rule” from the dropdown to the left of the Customize Rules button. Rules inform the folder sync mechanism what type of synchronization should be performed. A rule is a set of instructions detailing what to do in any given situation; replace older files with new, copy orphaned files, delete older files, etc. Using rule and folders selected the sync mechanism will scan the folders to generate a list of file differences which is displayed in a manner similar to a folder compare.

Once the user has specified the paths for the folders to be synced, the Go button should be pressed to initiate the scan of the folders to determine the differences between the files and what actions should be executed by the selected rule to synchronize the selected folders. If desired, the user may click on items in the Action column to customize the actions to be executed when the Start Sync button is pressed. When the user presses the Start Sync button the synchronization process is initiated and progress will be shown in the progress bar. The synchronization may be interrupted using the Cancel Sync button.

Note: The synchronization process will overwrite and delete files/folders in the compared folders. Once this process begins, the synchronization cannot be undone.

Pressing the Customize Rules button will cause the Rule Customization dialog to be displayed.

This dialog allows the user to create new rules and alter default rules. The user can select a rule to be modified and then alter the actions associated with that rule. There is also a field that allows the user to describe the actions executed by this rule.

If the user wishes to create a new rule, they must select "AddNew" from the Rule Name dropdown. This will cause the rule name to be replaced with "New Rule 0" and this should be modified as desired by the user.


Synchronized Vertical/Horizontal Scroll

This option synchronizes the compare panes so that both files may be scrolled vertically/horizontally at the same time by scrolling in either pane. The default is for both panes to be in sync. This command is used to re-establish synchronization if it is lost through a merge or other function.


Folder

Table (Configuration - Ignore Options)

The Table branch under Configuration - Ignore Options has the following options:

Ignore columns

This ignore option allows the user to specify that columns should not be compared based on Column labeling or header (if header is selected). For example: Ignore Column A, Ignore Column Address.

Ignore rows

This ignore option allows the user to specify that row should not be compared. For example: Ignore row 3.

Ignore cells containing

This ignore option allows the user to specify that cells containing user input data should be ignored. For example: Ignore cells containing ball, Ignore cells containing State

Ignore case

This ignore option will ignore the case of letters during comparison. For example Apple and apple would be displayed as the same.


Text

Text (Configuration - Compare)

The Text branch under Configuration - Compare has the following options for Text Compares:

Scaled/Scrollable Map

This option allows the user to select either Scaled map or Scrollable map controlling the display of the graphical navigation pane. If Scaled map is selected, differences are proportionately represented for the entirety of both compared files rather than shown as a scrollable map.

Use character to character line comparison

Normally UltraCompare uses a comparison method that tries to determine like sequences within a set of sequences - scanning a line for common letters and words to match against. If preferred, the customer may select this option to instruct UltraCompare to perform a character to character comparison instead. For files with long lines or large files, users may notice a significant decrease in compare times with this option selected.

Highlight

See - Highlighting Mode

Use double click to select word

If this option is selected, a mouse double click in the body of a file opened for text compare will select the word in which the caret is displayed rather than opening the active files in UltraEdit/UEStudio. When this option is selected, CTRL+Double Click should be used to open the active files in UltraEdit/UEStudio.

Use triple click to select line

If this option is selected, a mouse triple click in the body of a file opened for text compare will select the active line. When this option is selected, CTRL+Double Click should be used to open the active files in UltraEdit/UEStudio.


Text

Text (Configuration - Ignore Options)

The Text branch under Configuration - Ignore Options has the following options:

Ignore blank lines

This option forces the compare to ignore lines containing only line terminators when comparing the active files

Ignore case

This option forces the compare to ignore case when identifying differences in the active files

Ignore whitespace

This option forces the compare to ignore tabs and spaces when identifying differences in the active files

Ignore line terminators

This option forces the compare to ignore line terminator differences (DOS/UNIX/MAC) in the active files

Ignore lines which

This section may be used to define ignore rules based on strings at the beginning or end of lines or to ignore lines containing a specified string.

Ignore a defined number of lines

This section allows the user to define a number of lines at the beginning or end of a file to be ignored for compare purposes.


Text Mode

This option allows the user to switch the active compare to a text comparison regardless of what mode is active at the time this item is selected. When this mode is active a line-by-line comparison of the text in the compared files will be executed.

In the case of Word documents (.doc files), Rich Text Format (.rtf) files, or Portable Document Format (.pdf) files, when the compare begins the text strings will be extracted from the specified files to temporary files and the comparison will be executed against these. Due to the complex nature of Microsoft Word and Rich Text Documents, only the text information can be saved. All previous formatting will be lost. Renaming the file is advised and therefore when you click to save, UltraCompare Professional presents the Save As dialog first.


Main Toolbar

The Main toolbar includes the following functions:

Save Result | saves the result summary of the active compare as a text file
Close All Files | closes all open files
Print result | prints the result summary
Print Preview | displays the result summary onscreen as it would appear printed
All | displays the entire contents of both compared files
Just Differences | displays only the lines with differences
Just Matching | displays only the lines that are an exact match
Text Modes | displays submenu where user may select Text Mode or 3-Way Text Mode display options
Binary Modes | displays submenu where user may select Binary (fast) Mode or Binary (smart) Mode display options
Folder Modes | displays submenu where user may select Folder Mode or 3-Way Folder Mode display options
Vertical Layout | displays the compared files side-by-side
Horizontal Layout | displays the compared files with one on above the other
Configuration | presents configuration dialog
Toggle Word Wrap | toggles the Word Wrap state of the active document
Synchronize | scrolls both windows together
Synchronized Bottom Scroll | synchronizes the compare panes so that both files and the additional frames may be scrolled horizontally at the same time
Go to Next Difference | repositions to the next difference in the compared files
Go to Previous Difference | repositions to the previous difference in the compared files
Go to Previous Difference Characters | repositions to the previous difference in the differenced block
Go to Next Difference Characters | repositions to the next difference in the differenced block
Show File in Browser | passes active document to default browser for OS
Edit in UltraEdit | opens active file for editing in UltraEdit
About | displays About dialog


UE/UES Integration

The UE/UES Integration branch in Configuration includes the following options:

Load active file only

If this option is selected only the active file will be opened when the external editor is invoked rather than both files being compared.


Undo All Changes

This command may be used to reverse all changes in the active files/directories.


Using UltraCompare

UltraCompare may be used to compare the contents of two files or of two directories (more if the Recursive Compare option is selected). It may be invoked using several methods depending on what you wish to do and what version you're running (see Opening Files or Opening Folders ).

Please note: If you are running UltraCompare Lite then you would only be able to run UltraCompare while you have UltraEdit running as well. UltraCompare Pro may be run regardless of whether or not UltraEdit is running.

The default view of UltraCompare is split into two panes (for the files to be compared) with the menus and toolbar above. For details on opening and comparing files and folders please see Opening Files , Opening Folders , or Command Line Options .


Vertical Layout

This setting causes the compared files to be displayed side-by-side and is the default display option.


View Menu

The View menu offers the following commands:

Themes | presents a submenu where users may access the Manage Themes dialog or select an existing theme
Themes - Manage Themes | presents Manage Themes dialog where users may configure colors for the application
Toolbars | presents a submenu where users may select which toolbars to display
All | displays the entire contents of both compared files
Just Differences | displays only the lines with differences
Just Matching | displays only the lines that are an exact match
Center on Difference | repositions display such that current difference is centered
Show Output Window | displays the output window where the results of the commands executed for the active session are displayed
Show Explorer & Sessions | displays the Explorer & Sessions dialog including the Explorer and Sessions panes
Show Legend & Filters | displays the Legend & Filters dialog which explains the items displayed in the active compare and allows users to control which elements are displayed in the active compare
Show Preview File | displays preview file for active folder compare
Show Line Numbers | displays line numbers in the compared files
Show Spaces/Tabs | displays spaces, tabs, and new line characters as visible characters
Toggle Word Wrap | toggles the Word Wrap state of the active document
Relational Lines Mode | changes presentation of text compare to display linking and border lines for differenced blocks between matching blocks of text
Browser View | presents submenu where user may configure mode to be used for Browser View function
Synchronize | synchronizes the compare panes so that both files may be scrolled vertically at the same time
Refresh | repeats active compare updating the source and destination pane displays
Go | starts comparison of specified files/folders


Next Difference

Next Difference (Edit menu)

This command moves focus to the first line in the next group of lines marked as different.

Keyboard Shortcut: F3


Prev Difference

Prev Difference (Edit menu)

This command moves focus to the first line in the previous group of lines marked as different.

Keyboard Shortcut: F4


Window Menu

The Window menu offers the following commands:

Vertical Layout | displays the compared files side-by-side
Horizontal Layout | displays the compared files with one on above the other
Flip Frames | switches source/destination panes in active compare
Next Session Tab | switches focus to next active session
Previous Session Tab | switches focus to previous active session
Show File in Browser | passes active document to default browser for OS
Synchronized Vertical Scroll | synchronizes the compare panes so that both files may be scrolled vertically at the same time
Synchronized Horizontal Scroll | synchronizes the compare panes so that both files may be scrolled horizontally at the same time
Synchronized Bottom Scroll | synchronizes the compare panes so that both files and the additional frames may be scrolled horizontally at the same time

During a 3-Way Text Compare the Window menu offers the following commands:

Vertical Layout 3 Mode | displays the 3 compared files side-by-side
Horizontal Layout 3 Mode | displays the 3 compared files stacked one on top of the other
Flip First <--> Second | switches frames 1 and 2 in the active compare
Flip Second <--> Third | switches frames 2 and 3 in the active compare
Flip First <--> Third | switches frames 1 and 3 in the active compare
Next Session Tab | switches focus to next active session
Previous Session Tab | switches focus to previous active session
Show File in Browser | passes active document to default browser for OS
Synchronized Vertical Scroll | synchronizes the compare panes so that both files may be scrolled vertically at the same time
Synchronized Horizontal Scroll | synchronizes the compare panes so that both files may be scrolled horizontally at the same time
Synchronized Bottom Scroll | synchronizes the compare panes so that both files and the additional frames may be scrolled horizontally at the same time


Workspace Manager

Show Workspace Manager

Visibility of the Workspace Manager may be toggled by selecting Show Workspace Manager from the View menu or by pressing Ctrl+U. Users may toggle between the Explorer and Sessions tabs.

Explorer mode: displays tree view for local/network drives and removable media

If no items are selected in the Explorer pane of the Workspace Manager the following items are shown in the context menu:

System Explorer Menu | presents applicable parts of Windows Explorer context menu
Refresh | updates listing of all hard drives and removable media
Set Directory as Root | sets the active directory as root on right click and selection
Restore Default Root | restores original root directory

If a folder is selected in the Explorer pane of the Workspace Manager the following items are shown in the context menu:

System Explorer Menu | presents applicable parts of Windows Explorer context menu
Load into the first frame | loads selected folder into first frame of active folder compare
Load into the second frame | loads selected folder into second frame of active folder compare
Load into new session | launches new folder compare session and loads selected folder into first frame
Load into new 3-way session | launches new 3-way folder compare session and loads selected folder into first frame
Refresh | updates listing of all hard drives and removable media
Set Directory as Root | sets the active directory as root on right click and selection
Open Command Prompt Here | launches command prompt and sets to selected directory
Properties | displays Windows properties dialog for active folder
Delete | deletes selected folder(s)
Windows Directory | switches focus to Windows directory
System Directory | switches focus to System directory
My Documents | switches focus to My Documents directory for user
Programs Directory | switches focus to Windows Programs directory
Application | switches focus to Application Data directory

If a file is selected in the Explorer pane of the Workspace Manager the following items are shown in the context menu:

System Explorer Menu | presents applicable parts of Windows Explorer context menu
Load into the first frame | loads selected file into first frame of active file compare
Load into the second frame | loads selected file into second frame of active file compare
Load into new session | launches new file compare session and loads selected file into first frame
Load into new 3-way session | launches new 3-way file compare session and loads selected file into first frame
Open with Default | opens active file in application registered with Windows for file type
Properties | displays Windows properties dialog for active file
Delete | deletes selected file(s)
Windows Directory | switches focus to Windows directory
System Directory | switches focus to System directory
My Documents | switches focus to My Documents directory for user
Programs Directory | switches focus to Windows Programs directory
Application | switches focus to Application Data directory

Sessions mode: displays tree view for active sessions and groups

If no items are selected in the Sessions pane of the Workspace Manager the following items are shown in the context menu:

Add New Group | adds a new Group to the Sessions pane
Add active Session to new Group | adds a new Group to the Sessions pane and adds the active Session to the created Group

If a session group is selected in the Sessions pane of the Workspace Manager the following items are shown in the context menu:

Launch Group | launches selected Group
Rename Group | toggles selected Group label so that it may be modified
Add Active Session | adds active Session to active Group
Delete Group | deletes active Group

If a session is selected in the Sessions pane of the Workspace Manager the following items are shown in the context menu:

Launch Session | launches selected Session
Rename Session | toggles selected Session label so that it may be modified
Add to New Group | presents Save Active Session dialog where user may specify the name of the new group to which the selected session should be added
Session Properties | presents Session Properties dialog where user may modify options for the selected session
Delete Session | deletes selected Session